// 2015/01/16_12:11:24
// U.S. Patents No. 8095582, 8117197, 8442973 and 8543570.

//FOR-IE surfcanyonWrapperObject = function() {

var urlParams;

function getParams() {
	if (!urlParams) {
		urlParams = {};
		var query = window.location.search.substr(1).split('&');

		for (var i = 0; i < query.length; i++) {
			var param = query[i].split('=');
			if (param.length < 2) {
				continue;
			}
			urlParams[param[0]] = param[1];
		}
	}
	return urlParams;
}

function mergeProperties(container, newData) {
	for (var i in newData) {
		if (newData.hasOwnProperty(i)) {
			container[i] = newData[i];
		}
	}
};

YSShoppingBlock = null;

function appendSafeHtml(html, callback) {
	if (scIsFF && isMZ(SC.partner)) { // NO_MOZ
		sc_appendSafeHtml(html, callback);
		return; // NO_MOZ
	} // NO_MOZ
	callback(html); // NO_MOZ
}

(function() {
	var ddSelectors = {1:'compCardList', 2:'platc', 3:'crsl-sv-view'};
	var recRows = {};
	var rootElem = null;
	var runningFactory = null;
	var headerSpan = null;
	var rootTag = null;
	var rootClass = null;
	var recStub = null;
	var itemTag = null;
	var itemClass = null;

	getYahooShoppingBlockScheme = function() {
		for (var i in ddSelectors) {
			if (!ddSelectors.hasOwnProperty(i)) {
				continue;
			}
			var nodes = getElementsByClassName(ddSelectors[i]);
			if ((nodes) && nodes.length > 0) {
				return i;
			}
		}
		return null;
	}

	var getYSUrlHash = function(index) {
		return 'sc-yahoo-shopping-' + index;
	};

	var renderBoldTitle = function(title) {
		var boldTitle = '';
		title = title.split(' ');

		for (var i = 0; i < title.length; i++) {
			if (contains(SC.query, title[i].toLowerCase())) {
				boldTitle += ' <b>' + title[i] + '</b>';
			} else {
				boldTitle += ' ' + title[i];
			}
		}
		return boldTitle.trim();
	};

	var initRows = function(homeRow, tiles) {
		for (var i = 0; i < tiles.length; i++) {
			var urlHash = getYSUrlHash(i);
			tiles[i].setAttribute('scurlhash', urlHash);
			recRows[urlHash] = {home: homeRow, recsShown: false};
		}
	};

	var renderRec = function(rec) {
		var recNode = make(itemTag);
		recNode.className = itemClass;
		var title = scGetText(rec.getElementsByTagName('title')[0]);
		var h = recStub.replace(/%title%/g, title);
		h = h.replace(/%url%/g, scGetText(rec.getElementsByTagName('url')[0]));
		h = h.replace(/%image%/g, scGetText(rec.getElementsByTagName('imageUrl')[0]));
		h = h.replace(/%price%/g, scGetText(rec.getElementsByTagName('priceString')[0]));
		h = h.replace(/%seller%/g, scGetText(rec.getElementsByTagName('seller')[0]));
		h = h.replace(/%boldTitle%/g, renderBoldTitle(title));

		appendSafeHtml(h, function(html) {
			recNode.innerHTML = html;
		});

		recNode.setAttribute('scurlhash', scGetText(rec.getElementsByTagName('urlHash')[0]));
		return recNode;
	};

	var getNextRow = function(home) {
		for (var node = home.nextSibling; node !== null; node = node.nextSibling) {
			if (node.tagName.toLowerCase() === 'ul') { return node; }
		}
	};

	var addRow = function(recs, homeRow) {
		var recsContainer = rootElem.insertBefore(make(rootTag), getNextRow(homeRow));

		recsContainer.className = rootClass;
		recsContainer.setAttribute('scprocessed', 'true');

		for (var i = 0; i < recs.length; i++) {
			recsContainer.appendChild(recs[i]);
			recRows[recs[i].getAttribute('scurlhash')] = {home: recsContainer, recsShown: false};
		}
		return recsContainer;
	};

	function CardsBlock(selector) {
		rootTag = 'ul';
		rootClass = selector;
		recStub = '<span class="card-gradient" > <span class="media" > <a href="%url%" title="%title%" target="_blank"> <img title="%title%" src="%image%" class=""> </a> </span> <span class="content-overlay content"> <a href="%url%" title="%title%" target="_blank" class="title"> <h5>%boldTitle%</h5> </a> <p class="textsub">%price%</p> <cite> <span title="%seller%">%seller%</span> </cite> </span> </span>';
		itemTag = 'li';
		itemClass = 'card';

		rootElem = getElementsByTagAndClass('div', 'crsl-sv-view')[0];
		var ysOrganicUl = getChildrenByTagAndClass(rootElem, rootTag, rootClass)[0];

		if (!ysOrganicUl) {
			return this;
		}

		ysOrganicUl.setAttribute('scprocessed', 'true');

		var lis = getChildrenByTagName(ysOrganicUl, 'li');

		initRows(ysOrganicUl, lis);
	};

	function BoxesBlock(selector) {
		recStub = '<div class="pladitc" title="%title%"><a href="%url%" target="_blank"><img class="plaitc" src="%image%"></a></div><div class="placontc"><div class="plaltc" title="%title%"><a href="%url%" target="_blank">%boldTitle%</a></div><div class="plaptc">%price%</div><div class="plastc">%seller%</div></div>';
		rootTag = 'div';
		rootClass = selector;
		itemTag = 'div';
		itemClass = 'plaleft';

		rootElem = getElementsByTagAndClass('div', 'platc')[0];
		var boxes = getChildrenByTagAndClass(rootElem, 'div', 'plaleft');
		rootElem = rootElem.parentNode;

		initRows(rootElem, boxes);
	};

	function ListBlock(selector) {
		recStub = '<div class="wrap" ><div class="image" ><a class="thmb " href="%url%" target="_blank" title="%title%"><img class="s-img" alt="%title%" title="%title%" width="92" src="%image%" ></a></div><div class="content"><div class="txt"><a class="c-styl-5" href="%url%" target="_blank" title="%title%">%boldTitle%</a></div><div class="subTxt"><span class="c-styl-3"><b>%price%</b></span></div><div class="source"><span class="c-styl-2">%seller%</span></div><div class="time"></div></div></div>';
		rootTag = 'ul';
		rootClass = '';
		itemTag = 'li';
		itemClass = '';

		rootElem = getElementsByTagAndClass('div', selector)[0];
		var wrapperElem = getChildrenByTagName(rootElem, 'ul')[0];
		var blocks = getChildrenByTagName(rootElem, 'li');
		initRows(wrapperElem, blocks);
	};

	function shoppingBlockWrapper(block) {
		var factory = block;

		var addHeaderSpan = function(tag, className) {

			var ysOrganicUl = rootClass ? getChildrenByTagAndClass(rootElem, rootTag, rootClass)[0] : getChildrenByTagName(rootElem, rootTag)[0];
			headerSpan = make('span');
			headerSpan.style.display = 'block';
			headerSpan.style.paddingTop = '20px';
			headerSpan.style.paddingBottom = '20px';
			headerSpan.textContent = 'Product recommendations from Surf Canyon:';

			rootElem.insertBefore(headerSpan, ysOrganicUl.nextSibling);
		};

		this.addRecs = function(urlHash, recs) {
			var homeRow = recRows[urlHash];
			if (!homeRow || homeRow.recsShown) {
				return;
			}
			homeRow.recsShown = true;
			var results = recs.getElementsByTagName('result');

			if (results.length < 1) {
				return;
			}
			var addedRecs = [];
			for (var i = 0; i < results.length; i++) {
				var rec = renderRec(results[i]);
				addedRecs.push(rec);
			}

			if (addedRecs.length < 1) {
				return;
			}
			var addedRow = addRow(addedRecs, homeRow.home);

			if (!headerSpan) {
				addHeaderSpan();
			}
		};
	}

	getShoppingBlockFactory = function() {
		if (runningFactory) {
			return runningFactory;
		}

		var scheme = getYahooShoppingBlockScheme();
		var selector = null;
		if (scheme) {
		}
		switch (scheme) {
			case '1': {
				runningFactory = new shoppingBlockWrapper(new ListBlock(ddSelectors[scheme]));
			} break;
			case '2': {
				runningFactory = new shoppingBlockWrapper(new BoxesBlock(ddSelectors[scheme]));
			} break;
			case '3': {
				runningFactory = new shoppingBlockWrapper(new CardsBlock(ddSelectors[scheme]));
			} break;
			default: {
			}
			break;
		}
		return runningFactory;
	}
})();

(function() {
	var config = {};

	// no need for implementing prototypes, as a SERP object
	// will only be created once for the window
	GoogleSERP = function() {
		mergeProperties(config, {
			searchEngine: 'google',
			numResultsToken: ':NR=',
			cookieNewWindowToken: 'NW=1',
			batchSize: 50,
			numSRsForInitialUpload: 50,
			maxSRsToUpload: 100,
			searchQueryCommand: 'search',
			searchQueryTermArgName: 'q',
			searchQueryNumResultsArgName: 'num',
			searchQueryStartResultArgName: 'start',
			footerStartResultArgName: 'start',
			navbarDivName: 'nav'
		});

		this.extractUrlFromSRNode = function (srNode) {
			var urlTag = getChildrenByTagName(srNode, "cite")[0];
			return extractUrlFromSpanTag(urlTag);
		};
		this.scGetSRNodes = function () {
			var nodes = [], i;
			var tags = getTags('li');
			for (i = 0; i < tags.length; i++) {
				var tag = tags[i];
				var cls = tag.className;
				var h = tag.innerHTML;
				if ((cls == 'g') && contains(h, '<h3')) {
					// "div class="med" is a header for interstitial results.
					// "google.x(this,google.rt.pause)" is Latest Results.
					if (this.extractUrlFromSRNode(tag) && !contains(h, '<div class="med') && !contains(h, 'google.x(this,google.rt.pause)') && !contains(h, 'Pages similar to') && !contains(h, 'oi=local_result')) {
						nodes[nodes.length] = tag;
					}
				}
			}

			return nodes;
		};

		this.getBehavior = function() {
			return config;
		};
	};

	YahooSERP = function() {
		var ysConf = {
			searchEngine: 'yahoo',
			numResultsToken: 'n=',
			cookieNewWindowToken: 'nw=0',
			batchSize: 40,
			numSRsForInitialUpload: 80,
			maxSRsToUpload: 200,
			searchQueryCommand: 'search',
			searchQueryTermArgName: 'q',
			searchQueryNumResultsArgName: 'n',
			searchQueryStartResultArgName: 'b',
			footerStartResultArgName: 'b',
			navbarDivName: 'pg'
		};

		var q = getById("yschsp");
		if (q) {
			ysConf.query = q.value;
		}
		mergeProperties(config, ysConf);
		this.extractUrlFromSRNode = function (srNode) {
			var spanTag = getChildrenByTagAndClass(srNode, "span", "url")[0];
			return extractUrlFromSpanTag(spanTag);
		};

		this.scGetSRNodes = function () {
			var arr = [],
			i;
			var ol = getElementsByTagAndAttribute('ol', 'start', '1')[0];
			if (ol && ol.hasChildNodes) {
				for (i = 0; i < ol.childNodes.length; i++) {
					var node = ol.childNodes[i];
					var url = this.extractUrlFromSRNode(node);
					if (url && !contains(url, '.yahoo.com/search?')) {
						arr.push(node);
					}
				}
			}
			return arr;
		};

		this.getBehavior = function() {
			return config;
		};
	};

	YahooShoppingSERP = function() {

		// 'Product' page is internal yahoo terminology
		// referring to shopping.yahoo.com, as opposed
		// to 'shopping.search.yahoo.com'
		var isProductPage = function () {
			return contains(window.location.href, 'shopping.yahoo.com');
		}

		this.isProductPage = function () {
			return isProductPage();
		};

		var ysParent = new YahooSERP();

		mergeProperties(config, {
			searchEngine: 'yahoo_shopping',
			batchSize: 100,
			numSRsForInitialUpload: 300,
			maxSRsToUpload: 300
		});

		if (isProductPage() && isSC(SC.partner)) {
			config.query = getParams().p;
			config.searchQueryTermArgName = 'p';
			config.navbarDivName = 'pagination';
			config.batchSize = 16;
			numSRsForInitialUpload = 200;
			maxSRsToUpload = 200;
		}

		var getProductSnippet = function(node) {
			var snippet = "";

			var descNode = getChildrenByTagAndClass(node, 'p', 'desc')[0];

			if (descNode) {
				snippet = (descNode.textContent) ? descNode.textContent : null;
			}

			return snippet;
		};

		var getProductPrice = function(node) {
			var price = null;

			var priceNode = getChildrenByTagAndClass(node, 'a', 'price')[0];

			priceNode = priceNode ? priceNode : getChildrenByTagAndClass(node, 'p', 'price')[0];

			if ((priceNode) && priceNode.textContent) {
				price = priceNode.textContent;
				price = price.split('-')[0].trim();
			}

			return price;
		};

		var getProductTitleAndUrl = function(node) {
			var titleAndUrl = {
				title:null,
				url:null
			};
			var h2 = getChildrenByTagAndClass(node, 'h2', 'title')[0];
			var aTags = null;
			if (h2) {
				aTags = getChildrenByTagName(h2, 'a');
			};
			if (aTags.length) {
				titleAndUrl.title = aTags[0].title;
				titleAndUrl.url = aTags[0].href;
			}
			return titleAndUrl;
		};

		var resultIsValid = function(result) {
			var numProps = 0;
			for (var i in result) {
				if (!result.hasOwnProperty(i)) {
					continue;
				}
				numProps += (result[i] !== null) ? 1 : 0;
			}

			return numProps >= 6;
		};

		var extractProductUrlFromNode = function(node) {
			var h2 = getChildrenByTagAndClass(node, 'h2', 'title')[0];
			var aTags = null;
			if (h2) {
				aTags = getChildrenByTagName(h2, 'a');
			};
			return (aTags.length > 0) ? aTags[0].title : null;
		};

		this.extractUrlFromSRNode = function (srNode) {
			if (isProductPage()) {
				return extractProductUrlFromNode(srNode);
			}

			var aTags = getChildrenByTagName(srNode, 'a');
			return (aTags.length > 0) ? aTags[1].title : null;
		};

		var ypGetSRNodes = function() {
			var arr = new Array();
			var i;

			var ul = getElementsByTagAndClass("ul", 'hproducts')[0];
			if (!ul) {
				return arr;
			}

			var resNodes = getChildrenByTagAndClass(ul, 'li', 'hproduct');
			if (!resNodes) {
				return arr;
			}

			for (i = 0; i < resNodes.length; i++) {
				var node = resNodes[i];

				var url = extractProductUrlFromNode(node);
				if (url) {
					arr.push(node);
				}
			}
			return arr;
		};

		this.getBehavior = function() {
			return config;
		};

		var parseResultFromLi = function(li) {
			var result = {
				category:'',
				imageUrl:''
			};

			mergeProperties(result, getProductTitleAndUrl(li));
			result.snippet = getProductSnippet(li);
			result.price = getProductPrice(li);

			return result;
		};

		var domDiv = null;
		this.parseSRsFromResponse = function(html, arr) {
			if (!domDiv) {
				domDiv = make('div');
			}
			if (!arr) {
				arr = [];
			}

			appendSafeHtml(html.replace(/<script(.|\s)*?\/script>/g, ''), function(sHtml) {
				domDiv.innerHTML = sHtml;
			});

			var i;

			var ul = getChildrenByTagAndClass(domDiv, "ul", 'hproducts')[0];
			if (!ul) {
				return arr;
			}

			var resNodes = getChildrenByTagAndClass(ul, 'li', 'hproduct');
			if (!resNodes) {
				return arr;
			}

			for (i = 0; i < resNodes.length; i++) {
				var node = resNodes[i];

				var url = extractProductUrlFromNode(node);
				if (url) {
					var res = parseResultFromLi(node);
					if (res && resultIsValid(res)) {
						res.urlHash = getUrlHash(url);
						var scrapeNode = document.createElement('div');
						scrapeNode.appendChild(node.cloneNode(true));
						res.scrapedHtml = scrapeNode.innerHTML;
						arr.push(res);
					}
				}
			}
			return arr;
		};

		this.scGetSRNodes = function () {
			if (isProductPage()) {
				return ypGetSRNodes();
			}

			var arr = [],
			i;
			var olClass = onYahooShoppingGridView() ? 'grid' : 'list';

			var ol = getElementsByTagAndClass("ol", olClass)[0];
			if (ol && ol.hasChildNodes) {
				for (i = 0; i < ol.childNodes.length; i++) {
					var node = ol.childNodes[i];
					var url = this.extractUrlFromSRNode(node);
					if (url) {
						arr.push(node);
					}
				}
			}
			return arr;
		};
	};

})();

var SERP = null;

var ua = navigator.userAgent;

scIsOldIE = (ua.indexOf('MSIE') > 0);
scIsIE = scIsOldIE || (ua.indexOf('Trident') > 0);
scIsFF = (ua.indexOf('Firefox') > 0) && !scIsIE;
scIsChrome = (ua.indexOf('Chrome') > 0);
scIsSafari = (ua.indexOf("Safari") > 0) && !scIsChrome;

scInitializedByBackgroundPage = scIsChrome || scIsSafari;

function getById(name) {
	return document.getElementById(name);
}

function getTags(type) {
	return document.getElementsByTagName(type);
}

function make(type) {
	return document.createElement(type);
}

function startsWith(text, substring) {
	return text && substring && (text.indexOf(substring) === 0);
}

function endsWith(text, substring) {
	var b = false;
	if (text && substring) {
		var pos = text.lastIndexOf(substring);
		b = (pos != -1) && (pos == (text.length - substring.length));
	}
	return b;
}

function contains(text, substring) {
	return text && substring && (text.indexOf(substring) >= 0);
}

function truncateAtSpace(text, pos) {
	if (text) {
		text = text.trim();
		var spacePos = text.indexOf(' ', pos);
		if (spacePos >= pos) {
			text = text.substring(0, spacePos);
		}
	}

	return text;
}

function isServerError(s) {
	return s && startsWith(s, '<html><head><title>Apache Tomcat') && contains(s, '<body><h1>HTTP Status ');
}

function isOkServerResponse(s) {
	return s && (typeof s !== "undefined") && !isServerError(s);
}

function scGetTime() {
	return (Date.now ? Date.now() : (new Date()).getTime()).toString();
}

function getResponseText(xhr) {
	return scIsIE ? xhr.httpRequest.responseText : xhr.responseText;
}

function scGetText(s) {
	return (s ? (scIsOldIE ? s.text : s.textContent) : '');
}

function scXmlParser(text) {
	if (scIsOldIE) {
		var domParser = new ActiveXObject("Microsoft.XMLDOM");
		domParser.async = "false";
		domParser.loadXML(text);
		return domParser;
	} else {
		return (new DOMParser()).parseFromString(text, "text/xml");
	}
}

function onLiveServer() {
	return contains(SC.host, 'www');
}

function onTestServer() {
	return !onLiveServer();
}

function initChrome() {
	log = function (message) {
		if (onTestServer()) {
			chrome.extension.sendMessage({
				name : "appendLog",
				logContent : message
			});
		}
	};
}

function initFF() {
	alert = function (msg) {
		sc_alert(msg);
	};

	setTimeout = function (func, ms) {
		window.setFFTimeout(func, ms);
	};

	clearTimeout = function (func) {
		window.clearTimeout(func);
	};

	log = function (msg) {
		console.log(msg);
	};
}

function initSafari() {
	log = function (msg) {
		if (console && console.log && msg) {
			console.log(msg);
		}
	};
}

function initIE() {
	sc_ajax = function (params) {
		var httpRequest = window.surfcanyonObject.NewHttpRequest();

		var requestWrapper = {};
		requestWrapper.httpRequest = httpRequest;

		var url = params["url"];
		requestWrapper.url = url;

		httpRequest.open(params["method"], url, true);

		var headers = params["headers"];
		if (headers) {
			var header;
			for (header in headers) {
				httpRequest.setRequestHeader(header, headers[header]);
			}
		}

		var onload = params["onload"];
		var onerror = params["onerror"];
		httpRequest.onreadystatechange = function () {
			if (httpRequest.readyState == 4) {
				if (httpRequest.status == 200) {
					if (onload) {
						onload(requestWrapper);
					}
				} else {
					if (onerror) {
						onerror(requestWrapper);
					}
				}
			}
		};
		httpRequest.send(params["data"]);
	};

	EventRecord = function (event) {
		this.srcElement = event.srcElement;
		this.shiftKey = event.shiftKey;
		this.ctrlKey = event.ctrlKey;
		this.metaKey = event.metaKey;
		this.cancelBubble = true;
		this.returnValue = false;
	};

	log = function (msg) {
		if (console && console.log && msg) {
			console.log(msg);
		}
	};

	getBoolPreferenceValue = function (name) {
		return window.surfcanyonObject.GetPreference(name) == 1;
	};

	setBoolPreferenceValue = function (name, value) {
		window.surfcanyonObject.SetPreference(name, value ? 1 : 0);
	};

	getCharPreferenceValue = function (name) {
		return window.surfcanyonObject.GetPreference(name);
	};

	setCharPreferenceValue = function (name, value) {
		window.surfcanyonObject.SetPreference(name, value);
	};

	openNewTab = function (url) {
		window.open(url);
	};
}

function cancelEvent(event) {
	if (event) {
		if (event.stopPropagation) {
			event.stopPropagation();
		}
		if (event.preventDefault) {
			event.preventDefault();
		}
		event.cancelBubble = true;
		event.returnValue = false;
	}
}

function extractUrlFromSpanTag(spanTag) {
	var url = null;

	if (spanTag) {
		url = removeSimpleHtmlTags(spanTag.innerHTML);

		var endPos = url.indexOf(' - ');
		if (endPos > 0) {
			url = url.substring(0, endPos);
		}
	}

	return url;
}

function removeHref(node, addUnderlines) {
	try {
		if (node && node.href) {
			var url = node.href;
			node.setAttribute('scBackupHref', url);
			node.removeAttribute('href');

			node.style.cursor = "pointer";
			if (addUnderlines) {
				node.style.textDecoration = 'underline';
			}

			var args = url.replace(/%26/g, '&').split(/[&\?]/);
			var i;
			for (i = 0; i < args.length; i++) {
				var arg = args[i];
				var sepPos = arg.indexOf('=');
				if (sepPos != -1) {
					var name = arg.substring(0, sepPos);
					if (name === SC.footerStartResultArgName) {

						var start = arg.substring(sepPos + 1);
						node.setAttribute('scGotoPageStartVal', start);
						break;
					}
				}
			}
		}
	} catch (e) {
		console.log(e.message);
	}
}

function restoreHref(node) {
	try {
		var url = node.getAttribute('scBackupHref');
		node.setAttribute('href', url);
		node.removeAttribute('scBackupHref');
	} catch (e) {}
}

function interceptMoreResultsLinks() {
	var navbar = getNavbar();
	var i;
	var addUnderlines = onGoogleSerp();

	var nodes = getChildrenByTagName(navbar, 'a');
	for (i = 0; i < nodes.length; i++) {
		removeHref(nodes[i], addUnderlines);
	}

	if (onGoogleSerp()) {
		nodes = getChildrenByTagName(navbar, 'td');
		for (i = 0; i < nodes.length; i++) {
			var td = nodes[i];
			if (td.className === 'cur') {
				td.className = '';
			}
		}
	}

	return false;
}

function containsHtml(s) {
	return s && (s.indexOf('<') >= 0) && (s.indexOf('>') >= 0);
}

function getAdData() {
	var s = '';

	try {
		if (onYahooSerp()) {
			var liTags = getElementsByTagAndClass("li", "res");
			var i;
			var seenUrlHashes = {};
			for (i = 0; i < liTags.length; i++) {
				try {
					var liTag = liTags[i];
					if (contains(liTag.className, 'bgclickable')) {
						s = s + processYahooAd(liTag, i, seenUrlHashes);
					}
				} catch (e) {
				}
			}
		}
	} catch (e) {
		log(e.message);
	}

	return s;
}

function processYahooAd(node, i, seenUrlHashes) {
	var s = '';

	try {
		var titleDiv = getChildrenByTagAndClass(node, 'div', 'ad-ttl')[0];
		var titleLink = getChildrenByTagName(titleDiv, 'a')[0];
		var snippetDiv = getChildrenByTagAndClass(node, 'div', 'abs')[0];
		var snippetLink = getChildrenByTagName(snippetDiv, 'a')[0];
		var em = getChildrenByTagName(node, 'em')[0];
		var aTagFromEm = em ? em.getElementsByTagName('a')[0] : null; // may optionally be nested inside an img

		if (titleLink && snippetLink && aTagFromEm) {
			var title = removeSimpleHtmlTags(titleLink.textContent);
			var snippet = removeSimpleHtmlTags(snippetLink.textContent);
			var displayUrl = removeSimpleHtmlTags(aTagFromEm.textContent);

			var attrVal = node.getAttribute('scUrlHash');
			if (!attrVal) {
				var urlHash = getUrlHash(displayUrl + "ad" + title);
				if (!(urlHash in seenUrlHashes)) {
					seenUrlHashes[urlHash] = 1;

					node.setAttribute('scUrlHash', urlHash);

					var recsSpan = make('div');
					recsSpan.setAttribute('id', 'scRecs' + urlHash);
					node.appendChild(recsSpan);

					s = '&adTitle' + i + '=' + encodeURIComponent(title) + '&adSnippet' + i + '=' + encodeURIComponent(snippet) + '&adDisplayUrl' + i + '=' + encodeURIComponent(displayUrl);
				}
			}
		}
	} catch (e) {
		log(e.message);
	}

	return s;
}

function getTitleTag(srNode) {
	var title = null;

	if (onGoogleSerp()) {
		var nodes = getChildrenByTagName(srNode, "h3");
		if (nodes.length === 0) {
			nodes = getChildrenByTagName(srNode, "h2");
		}

		if (nodes.length > 0) {
			title = nodes[0];
		} else {
			nodes = getChildrenByTagName(srNode, "a");
			if (nodes.length > 0) {
				title = nodes[0];
			}
		}
	} else if (onYahooSerp() || onYahooShopping()) {
		title = getChildrenByTagName(srNode, "h3")[0];
	}

	return title;
}

function getNavbar() {
	var navbar = getById(SC.navbarDivName);
	if (!navbar) {
		navbar = getElementsByClassName(SC.navbarDivName)[0];
	}
	return navbar;
}

function determineLinkType(node) {
	var linkType = null;
	var text;
	var attrVal = node.getAttribute('scGotoPageStartVal');
	if (attrVal) {
		if (onGoogleSerp()) {
			text = node.innerHTML.replace(/\s+$/g, '');
			var lastChar = text.charAt(text.length - 1);
			linkType = (lastChar >= '1' && lastChar <= '9') ? 'Goto' : 'Next';
		} else if (onYahooSerp() || onYahooShopping()) {
			text = node.innerHTML;
			linkType = (text.length > 2) ? 'Next' : 'Goto';
		}
	}

	return linkType;
}

function pruneHtml(html) {
	if (onGoogleSerp()) {
		var pos = html.indexOf('<div id=res');
		if (pos != -1) {
			html = html.substring(pos);
		}

		pos = html.indexOf('<div id="center_col"');
		if (pos != -1) {
			html = html.substring(pos);
		}

		pos = html.indexOf('<!--z--');
		if (pos != -1) {
			html = html.substring(0, pos);
		}

		html = html.replace(/onmousedown=".*?"/g, '');
		html = html.replace(/onmouseover=".*?"/g, '');

		html = html.replace(/<span class=vshid>.*?<\/span>/g, '');
	}

	return html;
}

function getElementsByTagAndAttribute(tag, attrName, attrVal) {
	var elements = getTags(tag);
	var arr = [],
	i,
	len = elements.length;
	for (i = 0; i < len; i++) {
		var element = elements[i];
		if (element.getAttribute(attrName) == attrVal) {
			arr[arr.length] = element;
		}
	}
	return arr;
}

function getElementsByClassName(className) {
	return document.getElementsByClassName(className);
};

function getElementsByTagAndClass(tag, className) {
	var s = className + ' ';
	var e = ' ' + className;
	var m = ' ' + className + ' ';
	var elements = getTags(tag);
	var arr = [],
	i,
	len = elements.length;
	for (i = 0; i < len; i++) {
		var element = elements[i];
		var cn = element.className;
		if ((cn == className) || startsWith(cn, s) || endsWith(cn, e) || contains(cn, m)) {
			arr[arr.length] = element;
		}
	}
	return arr;
}

function getChildrenByTagName(node, tagName) {
	var arr = [],
	i;
	if (node && node.childNodes) {
		var childNodes = node.childNodes;
		var len = childNodes.length;
		for (i = 0; i < len; i++) {
			var child = childNodes.item(i);
			if (child.tagName && (!tagName || (child.tagName.toUpperCase() == tagName.toUpperCase()))) {
				arr[arr.length] = child;
			}
			if (child.hasChildNodes()) {
				arr = arr.concat(getChildrenByTagName(child, tagName));
			}
		}
	}
	return arr;
}

function getChildrenByTagAndAttribute(node, tagName, attrName, attrVal) {
	var children = getChildrenByTagName(node, tagName);
	var arr = [],
	i,
	len = children.length;
	for (i = 0; i < len; i++) {
		var child = children[i];
		if (child.getAttribute(attrName) == attrVal) {
			arr[arr.length] = child;
		}
	}
	return arr;
}

function getChildrenByTagAndClass(node, tagName, className) {
	var s = className + ' ';
	var e = ' ' + className;
	var m = ' ' + className + ' ';
	var children = getChildrenByTagName(node, tagName);
	var arr = [],
	i,
	len = children.length;
	for (i = 0; i < len; i++) {
		var child = children[i];
		var cn = child.className;
		if ((cn == className) || startsWith(cn, s) || endsWith(cn, e) || contains(cn, m)) {
			arr[arr.length] = child;
		}
	}
	return arr;
}

function getDomainName(url) {
	if (startsWith(url, "http://")) {
		url = url.substring(7);
	} else if (startsWith(url, "https://")) {
		url = url.substring(8);
	} else if (startsWith(url, "ftp://")) {
		url = url.substring(6);
	}

	if (startsWith(url, "www.")) {
		url = url.substring(4);
	}

	var pos = url.indexOf('/');
	if (pos != -1) {
		url = url.substring(0, pos);
	}

	pos = url.indexOf(' ');
	if (pos != -1) {
		url = url.substring(0, pos);
	}

	return url;
}

function bigRandom() {
	var r1 = ('' + Math.random()).substring(2);
	var r2 = ('' + Math.random()).substring(2);
	return r1 + r2;
}

function getBoolPref(prefName) {
	var val = false;

	try {
		val = getBoolPreferenceValue(prefName);
	} catch (e) {}

	return val;
}

function getCharPref(prefName) {
	var val = null;

	try {
		val = getCharPreferenceValue(prefName);
	} catch (e) {}

	return val;
}

function getAllDisabled() {
	return getBoolPref('disabled');
}

function setAllDisabled(val) {
	var oldValue = getAllDisabled() ? 1 : 0;
	var newValue = val ? 1 : 0;
	var changed = (newValue != oldValue);

	if (changed) {
		setBoolPreferenceValue("disabled", val);
	}
}

function getDisplaySimilarProductImages() {
	return getBoolPref('display_similar_product_images_enabled');
}

function setDisplaySimilarProductImages(val) {
	setBoolPreferenceValue('display_similar_product_images_enabled', val);
}

function getShowRecsOnSRClick() {
	return getBoolPref("get_recs_on_sr_click");
}

function setShowRecsOnSRClick(val) {
	setBoolPreferenceValue("get_recs_on_sr_click", val);
}

function getMaxNumRecsForSRSelection() {
	return getCharPref("max_num_recs");
}

function setMaxNumRecsForSRSelection(val) {
	setCharPreferenceValue("max_num_recs", val);
}

function getCachedRefinements() {
	return getCharPref("refinements_cache");
}

function cacheRefinements(node) {
	var key = SC.query.toLowerCase().replace(/\+/g, ' ');
	var keyWithSlash = key + '/';
	var refinements = extractRefinementsText(node).join(':').toLowerCase();
	var refSet = keyWithSlash + refinements;

	var cache = getCachedRefinements();
	cache = cache ? cache : '';

	if (!contains(cache, '^' + refSet)) {
		var arr = cache.split('^');

		if (cache.length + refSet.length > 2500) {
			arr.shift();
		}

		if (contains(cache, keyWithSlash)) {
			var i,
			len = arr.length;
			for (i = 0; i < len; i++) {
				var entry = arr[i];
				if (startsWith(entry, keyWithSlash)) {
					arr[i] = addRefinementsToCacheEntry(entry, refinements);
					break;
				}
			}
		} else {
			arr.push(refSet);
		}

		setCharPreferenceValue("refinements_cache", arr.join('^'));
	}
}

function extractRefinementsText(node) {
	var arr = [];

	if (node) {
		var aTags = node.getElementsByTagName('a');
		var i,
		len = aTags.length;
		for (i = 0; i < len; i++) {
			var aTag = aTags[i];
			if (contains(aTag.href, ".surfcanyon.com/search?") || startsWith(aTag.href, "http://localhost/search?")) {
				arr.push(scIsOldIE ? aTag.innerText : aTag.textContent);
			}
		}
	}

	return arr;
}

function addRefinementsToCacheEntry(entry, refinements) {
	var tmpArray = entry.split('/');
	var key = tmpArray[0];
	var curRefinements = tmpArray[1].split(':');
	var refinementsToAdd = refinements.split(':');
	var newRefinements = [];

	var i,
	ref,
	len = curRefinements.length;
	for (i = 0; i < len; i++) {
		ref = curRefinements[i];
		if (ref) {
			addToArrayWithNoDups(newRefinements, ref);
		}
	}
	len = refinementsToAdd.length;
	for (i = 0; i < len; i++) {
		ref = refinementsToAdd[i];
		if (ref) {
			addToArrayWithNoDups(newRefinements, ref);
		}
	}

	return key + '/' + newRefinements.join(':');
}

function getInstId() {
	var instId = getCharPref("inst_id");
	instId = instId ? instId : setInstId(bigRandom());
	return instId;
}

function setInstId(value) {
	setCharPreferenceValue("inst_id", value);
	return value;
}

function getPartner() {
	var pc = getCharPref("partner_code");
	return pc ? pc : 'SC';
}

function setPartner(value) {
	setCharPreferenceValue("partner_code", value);
}

function getInstTimestamp() {
	var instTs = getCharPref("inst_timestamp");
	instTs = instTs ? instTs : setInstTimestamp(scGetTime());
	return instTs;
}

function setInstTimestamp(value) {
	value = value.toString();
	setCharPreferenceValue("inst_timestamp", value);
	return value;
}

function getDynamicPreferencesTimestamp() {
	return getCharPref("dynamic_preferences_timestamp");
}

function setDynamicPreferencesTimestamp(value) {
	setCharPreferenceValue("dynamic_preferences_timestamp", value);
}

function getLastSeenSplash() {
	return getCharPref("last_seen_splash");
}

function setLastSeenSplash(value) {
	setCharPreferenceValue("last_seen_splash", value);
}

function getGoogleSearchButtonClickTimestamp() {
	return getCharPref("google_search_button_click_ts");
}

function setGoogleSearchButtonClickTimestamp(value) {
	setCharPreferenceValue("google_search_button_click_ts", value);
}

function getGoogleSearchButtonClickQuery() {
	return getCharPref("google_search_button_click_query");
}

function setGoogleSearchButtonClickQuery(value) {
	setCharPreferenceValue("google_search_button_click_query", value);
}

function getSearchLinksEnabled() {
	return getBoolPref("search_links_enabled");
}

function setSearchLinksEnabled(val) {
	setBoolPreferenceValue("search_links_enabled", val);
}

function getServerSidePageLinksEnabled() {
	return getBoolPref("ss_page_links_enabled");
}

function setServerSidePageLinksEnabled(val) {
	setBoolPreferenceValue("ss_page_links_enabled", val);
}

function getRefinementLinksEnabled() {
	return getBoolPref("refinement_links_enabled");
}

function setRefinementLinksEnabled(val) {
	setBoolPreferenceValue("refinement_links_enabled", val);
}

function getRoamingSuggestionsEnabled() {
	return getBoolPref("roaming_suggestions_enabled");
}

function setRoamingSuggestionsEnabled(val) {
	setBoolPreferenceValue("roaming_suggestions_enabled", val);
}

function getOdometerDisabled() {
	return getBoolPref("odometer_disabled");
}

function setOdometerDisabled(val) {
	setBoolPreferenceValue("odometer_disabled", val);
}

function getCharPrefAsNum(name) {
	var num = 0;

	try {
		num = getCharPref(name);
		if (typeof num != 'number') {
			if (!num || (num.length === 0) || (num.charAt(0) < '0') || (num.charAt(0) > '9')) {
				num = 0;
			}
		}
	} catch (e) {}

	return num;
}

function incrementPref(name) {
	var num = 0;
	try {
		num = Number(getCharPrefAsNum(name));
	} catch (e) {}

	setCharPreferenceValue(name, num + 1);
}

function clearPref(name) {
	setCharPreferenceValue(name, 0);
}

function getNumSearches() {
	return getCharPrefAsNum("num_searches");
}

function incNumSearches() {
	if (!getOdometerDisabled()) {
		incrementPref("num_searches");
	}
}

function clearNumSearches() {
	clearPref("num_searches");
}

function getNumResultsClicked() {
	return getCharPrefAsNum("num_results_clicked");
}

function incNumResultsClicked() {
	if (!getOdometerDisabled()) {
		incrementPref("num_results_clicked");
	}
}

function clearNumResultsClicked() {
	clearPref("num_results_clicked");
}

function getNumResultsClickedWhenRecsAvailable() {
	return getCharPrefAsNum("num_results_clicked_when_recs_available");
}

function incNumResultsClickedWhenRecsAvailable() {
	if (!getOdometerDisabled()) {
		incrementPref("num_results_clicked_when_recs_available");
	}
}

function clearNumResultsClickedWhenRecsAvailable() {
	clearPref("num_results_clicked_when_recs_available");
}

function getNumRecsClicked() {
	return getCharPrefAsNum("num_recs_clicked");
}

function incNumRecsClicked() {
	if (!getOdometerDisabled()) {
		incrementPref("num_recs_clicked");
	}
}

function clearNumRecsClicked() {
	clearPref("num_recs_clicked");
}

function getSearchBoost() {
	var val = '-';

	var divisor = getNumResultsClickedWhenRecsAvailable();
	if (divisor > 0) {
		val = Math.round(getNumRecsClicked() / divisor * 100) + '%';
	}

	return val;
}

function getLangFromDomain(domain) {
	var lang;
	var ct = null;

	if (domain.length > 4) {
		if (domain.charAt(2) == '.') {
			ct = domain.substring(0, 2);
		} else if (domain.charAt(domain.length - 3) == '.') {
			ct = domain.substring(domain.length - 2);
		}
	}

	if (ct == 'mx' || ct == 'es' || ct == 'ar' || ct == 'cl' || ct == 'cr' || ct == 'pe' || ct == 'pr' || ct == 'uy' || ct == 'py' || ct == 'bo') {
		lang = 'es';
	} else if (ct == 'br' || ct == 'pt') {
		lang = 'pt';
	} else if (ct == 'de' || ct == 'at') {
		lang = 'de';
	} else if (ct == 'it' || ct == 'fr' || ct == 'nl' || ct == 'fi' || ct == 'no' || ct == 'ru' || ct == 'fi' || ct == 'hu' || ct == 'ro' || ct == 'tr') {
		lang = ct;
	} else if (ct == 'dk') {
		lang = 'da';
	} else if (ct == 'se') {
		lang = 'sv';
	} else {
		lang = 'en';
	}

	return lang;
}

// Creates a text area with which to decode a query
// string found on the page or in URL parameters. S is
// never remote HTML content so this operation should be
// safe from XSS attacks.
function decodeEntities(s) {
	var textarea = make("textarea");
	textarea.innerHTML = s;
	return textarea.value;
}

function removeChildren(element) {
	if (element && element.hasChildNodes()) {
		while (element.childNodes.length >= 1) {
			element.removeChild(element.firstChild);
		}
	}
}

function removeSimpleHtmlTags(s, retainImageTags) {
	var openImgTag = retainImageTags ? '<img' : null;
	var closeImgTag = retainImageTags ? '</img' : null;

	if (s) {
		var output = '',
		i;
		var len = s.length;
		var inTag = false;
		for (i = 0; i < len; i++) {
			var c = s.charAt(i);

			if (!inTag && (c == '<') && (s.substr(i, 4) != openImgTag) && (s.substr(i, 5) != closeImgTag)) {
				inTag = true;
			} else if (inTag && (c == '>')) {
				inTag = false;
			} else if (!inTag) {
				output += c;
			}
		}
		return output;
	} else {
		return s;
	}
}

function getNumResultsPerPage() {
	var num = 10,
	i;

	var cookieParts = document.cookie.split('; ');
	for (i = 0; i < cookieParts.length; i++) {
		var cookiePart = cookieParts[i];
		if (onYahooSerp() && !startsWith(cookiePart, 'sS=')) {
			continue;
		}

		var pos = cookiePart.indexOf(SC.numResultsToken);
		if (pos > 0) {
			num = parseInt(cookiePart.substring(pos + SC.numResultsToken.length));
			break;
		}
	}

	return num;
}

function inNewWindowMode() {
	var inNewWindowMode = false;
	if ((typeof SC.cookieNewWindowToken != 'undefined') && SC.cookieNewWindowToken) {
		var cookieParts = document.cookie.split('; ');
		var i;
		for (i = 0; i < cookieParts.length; i++) {
			var cookiePart = cookieParts[i];
			var containsToken = contains(cookiePart, SC.cookieNewWindowToken);
			var isMatch = (onYahooSerp() || onYahooShopping()) ? (!containsToken) : containsToken;
			if (isMatch) {
				inNewWindowMode = true;
				break;
			}
		}
	}

	return inNewWindowMode;
}

function linkClickOpensNewWindow(event) {
	return (event.shiftKey || event.ctrlKey || event.metaKey) ? true : inNewWindowMode();
}

function getPageUrl() {
	// make a new copy of window.location
	return '' + window.location;
}

function getSSMapKey() {
	return getUrlHash(SC.currentDomain + SC.query);
}

function searchEngineQueryURL(query, numToGet, startNum) {
	var domain = SC.currentDomain;
	if (SC.searchEngine == 'bing') {
		domain = 'search.yahoo.com';
	} else if (startsWith(domain, 'encrypted.')) {
		domain = domain.replace('encrypted.', 'www.');
	}
	var url = window.location.protocol + '//' + domain;

	var loc = scIsFF ? window.top.location : window.location;
	var argsString = loc.search.substring(1);

	// google search string comes from a link, so it's already encoded
	if (!onGoogleSerp()) {
		query = encodeURIComponent(query);
	}

	url += ('/' + SC.searchQueryCommand + '?' + SC.searchQueryTermArgName + '=' + query);
	if (SC.searchQueryNumResultsArgName) {
		url += ('&' + SC.searchQueryNumResultsArgName + '=' + numToGet);
	}
	if (SC.searchQueryStartResultArgName) {
		url += ('&' + SC.searchQueryStartResultArgName + '=' + startNum);
	}

	if (onGoogleSerp() || onYahooSerp()) {
		var args = argsString.split('&');
		var i;
		for (i = 0; i < args.length; i++) {
			var arg = args[i];
			var sepPos = arg.indexOf('=');
			if (sepPos != -1) {
				var name = arg.substring(0, sepPos);
				var value = arg.substring(sepPos + 1);
				if (name != SC.searchQueryTermArgName &&
					name != SC.searchQueryNumResultsArgName &&
					name != SC.searchQueryStartResultArgName) {
					url = url + '&' + name + '=' + value;
				}
			} else {
				url = url + '&' + arg;
			}
		}
	}

	if (onGoogleSerp()) {
		var amp = endsWith(url, '&') ? '' : '&';
		url = url + amp + 'as_qdr=all';
	}
	return url;
}

function parseAndUploadJSONSRs(html) {
	var recs = [];
	try {
		recs = SERP.parseSRsFromResponse(html, recs);
		doUploadJSONSRs(recs);
	} catch (e) {
	}
	return recs;
};

function doUploadJSONSRs(results) {
	results = JSON.stringify(results);
	results = encodeURIComponent(results);
	var params = 'ssMapKey=' + getSSMapKey() +
				 '&q=' + SC.query +
				'&instId=' + SC.instId +
				'&extensionVersion=' + SC.extensionVersion +
				'&isJson=1';
				
	params += '&srPayloadHtml=' + results;
	sc_ajax({
		url: SC.host + "search/upload",
		headers : {
			'Content-type' : 'application/x-www-form-urlencoded'
		},
		data: params,
		method: 'POST',
		onload: function (xhr) {
			if (!SC.firstBatchReceived) {
				SC.firstBatchReceived = true;
			}

			SC.numBatchesLeftToUpload--;
			if (SC.numBatchesLeftToUpload > 0) {
				SC.batchNum++;
				uploadSRs();
			}
		},
		onerror : function (xhr) {
			handleConnectionError('uploadJSONSRs2', url);
		}
	});
}

function uploadSRs(searchTerm) {
	if (SC.uploadResults && SC.numSRsForInitialUpload) {
		var startNum = (SC.batchNum - 1) * SC.batchSize;
		var query = searchTerm||SC.query;
		var url = searchEngineQueryURL(query, SC.batchSize, startNum);
		sc_ajax({
			method : 'GET',
			url : url,
			onload : function (xhr) {
				var html = getResponseText(xhr);

				if ((SERP.isProductPage) && SERP.isProductPage()) {
					parseAndUploadJSONSRs(html);
					return;
				}

				if (SC.query == query) { // could differ due to Google Instant

					if (html.match(/<html/i) || html.match(/<!doctype html/i)) {
						doUploadSRs(html, query);
					} else {
						handleConnectionError('uploadSRs1', url);
					}
				}
			},
			onerror : function (xhr) {
				handleConnectionError('uploadSRs2', url);
			}
		});
	}
}

function doUploadSRs(html, query) {
	html = pruneHtml(html);

	var url = SC.host + 'search/upload';
	sc_ajax({
		method : 'POST',
		url : url,
		headers : {
			'Content-type' : 'application/x-www-form-urlencoded'
		},
		data : 'ssMapKey=' + getSSMapKey() +
		'&instId=' + SC.instId +
		'&extensionVersion=' + SC.extensionVersion +
		'&srPayloadHtml=' + encodeURIComponent(html),
		onload : function (xhr) {
			var text = getResponseText(xhr);
			if (isOkServerResponse(text)) {
				var xmlRoot = scXmlParser(text);
				var data = xmlRoot.getElementsByTagName('data')[0];
				if (data) {
					if (!SC.firstBatchReceived) {
						SC.firstBatchReceived = true;

						var node = data.getElementsByTagName('moreResultsAvailable')[0];
						if (scGetText(node) != '1') {
							removeMoreResultsLinks();
						}

						node = data.getElementsByTagName('notEnoughResults')[0];
						if (scGetText(node) == '1') {
							handleConnectionError('doUploadSRs1', null);
						}
					}

					if (SC.bufferedEvent) {
						clickHandler(SC.bufferedEvent);
						SC.bufferedEvent = null;
					}

					SC.numBatchesLeftToUpload--;
					if (SC.numBatchesLeftToUpload > 0) {
						SC.batchNum++;
						uploadSRs(query);
					}
				}
			} else {
				if (SC.batchNum == 1) {
					handleConnectionError('doUploadSRs2', url);
				}
			}
		},
		onerror : function () {
			if (SC.batchNum == 1) {
				handleConnectionError('doUploadSRs3', url);
			}
		}
	});
}

function uploadMoreSRs() {
	if (SC.uploadResults && ((SC.batchNum + 1) * SC.batchSize <= SC.maxSRsToUpload)) {
		SC.batchNum++;
		uploadSRs();
	}
}

function doGetSRByUrlHash(urlHash) {
	var list = getChildrenByTagAndAttribute(document.body, null, 'scUrlHash', urlHash);
	return (list.length > 0) ? list[0] : null;
}

function getSRByUrlHash(urlHash) {
	if (startsWith(urlHash, 'www')) {
		urlHash = urlHash.substring(3);
	}

	var srNode = doGetSRByUrlHash(urlHash);
	if (!srNode) {
		srNode = doGetSRByUrlHash('www' + urlHash);
	}

	return srNode;
}

function getRecsSpan(urlHash) {
	var span = getById('scRecs' + urlHash);
	if (!span) {
		if (startsWith(urlHash, 'www')) {
			urlHash = urlHash.substring(3);
			span = getById('scRecs' + urlHash);
		} else {
			span = getById('scRecswww' + urlHash);
		}
	}
	return span;
}

function updateRecsInUI(urlHash, recs, data, updateAttrs) {
	if (onYahooShoppingGridView()) {
		YSGridRows.addRecs(urlHash, scGetText(recs));
		return;
	}

	var span = getRecsSpan(urlHash);
	if (recs) {
		if (span && span.getAttribute('scIsOrganicResult')) {
			var recsHtml = "<table style='clear: both;'>" + scGetText(recs) + "</table>";

			appendSafeHtml(recsHtml, function(html) {
				span.innerHTML = html;
				if (updateAttrs) {
					updateAttributesAfterUi(data);
				}
			});

			cacheRefinements(span);
		} else if ((startsWith(urlHash, 'sc-yahoo-shopping')) && YSShoppingBlock) {
			YSShoppingBlock.addRecs(urlHash, recs);
		} else if (span) {
			var results = recs.getElementsByTagName('result');
			var len = results.length;
			if (len) {
				var div = make('div');
				div.style.marginBottom = '10px';
				div.style.fontWeight = 'bold';
				div.textContent = 'Recommended ads from Surf Canyon';
				span.appendChild(div);

				for (i = 0; i < len; i++) {
					var rec = results[i];
					var urlHash = scGetText(rec.getElementsByTagName('urlHash')[0]);
					var url = scGetText(rec.getElementsByTagName('url')[0]);
					var displayUrl = scGetText(rec.getElementsByTagName('displayUrl')[0]);
					var title = scGetText(rec.getElementsByTagName('title')[0]);
					var snippet = scGetText(rec.getElementsByTagName('snippet')[0]);
					renderYahooAd(span, urlHash, url, displayUrl, title, snippet, (i < len - 1));
				}

				span.style.paddingTop = '20px';
				span.style.paddingLeft = '60px';
			}
		}

		installSCClickHandlers(span);
	}
}

function updateAttributesAfterUi(data) {
	if (scIsFF && isMZ(SC.partner)) {
		var metaTags = data.getElementsByTagName('srsMetaData');
		var recs = [];

		for (var n = 0; n < metaTags.length; n++) {
			recs = metaTags[n].getElementsByTagName('rec');

			for (var i = 0; i < recs.length; i++) {
				var rec = recs[i];
				try {
					var urlHash = scGetText(rec.getElementsByTagName('urlHash')[0]);
					var isOrganic = scGetText(rec.getElementsByTagName('isOrganic')[0]);
					var srType = scGetText(rec.getElementsByTagName('srType')[0]);

					var node = getById(urlHash);
					if (!node || node.getAttribute('scAttrsUpdated')) {
						continue;
					}

					node.setAttribute('scUrlHash', urlHash);
					node.setAttribute('scAttrsUpdated', '1');

					if (isOrganic === '1') {
						node.setAttribute('scIsOrganicResult', isOrganic);
					}

					node = getRecsSpan(urlHash);
					if (node) {
						node.setAttribute('scIsOrganicResult', isOrganic);
						node.setAttribute('srType', srType);
					}

				} catch (e7) {
				}
			}

		}
	}
}

function updateUIAfterSelection(data, displayRecs, urlHash, gesture) {
	if (displayRecs && !getAllDisabled()) {
		var srNode = getSRByUrlHash(urlHash);
		var recs = data.getElementsByTagName('recs')[0];
		if (srNode) {
			updateRecsInUI(urlHash, recs, data, true);
		}
	}
}

var refinedQueries = {};
function runAugmentedQuery(data) {
	SC.numBatchesLeftToUpload += 3;
	var augmentedQuery = scGetText(data.getElementsByTagName('refinedQuery')[0]);
	if (augmentedQuery && !refinedQueries[augmentedQuery]) {

		refinedQueries[augmentedQuery] = 1;
		uploadSRs(augmentedQuery);
	}
}

function getRecs(urlHash, displayRecs, gesture, openNewWindow) {
	if (SC.gettingRecs || getAllDisabled()) {
		return;
	}

	SC.gettingRecs = true;

	var maxNumRecs = ((gesture == 'click' || gesture == 'rightClick') && !getShowRecsOnSRClick()) ? 0 : getMaxNumRecsForSRSelection();
	var url = SC.host + 'search/selectSearchResult?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&gesture=' + gesture + '&maxNumRecs=' + maxNumRecs + '&urlHash=' + urlHash + '&openNewWindow=' + (openNewWindow ? '1' : '0') + SC.useGridView;
	sc_ajax({
		method : 'GET',
		url : url,
		onload : function (xhr) {
			try {
				var text = getResponseText(xhr);
				if (isOkServerResponse(text)) {
					var xmlRoot = scXmlParser(text);
					var data = xmlRoot.getElementsByTagName('data')[0];

					if (data) {
						updateUIAfterSelection(data, displayRecs, urlHash, gesture);

						runAugmentedQuery(data);

						SC.srSelectionCount++;
						if (SC.srSelectionCount === 3) {
							SC.srSelectionCount = 0;
							uploadMoreSRs();
						}
					}
				}
			} catch (e) {
				log('error getting recs: ' + e.message);
			}
			finally {
				SC.gettingRecs = false;
			}
		},
		onerror : function () {
			SC.gettingRecs = false;
			handleConnectionError('getRecs', url);
		}
	});
}

function closeRecs(urlHash) {
	sc_ajax({
		method : 'GET',
		url : SC.host + 'search/closeRecs?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&urlHash=' + urlHash
	});

	var span = getRecsSpan(urlHash);
	removeChildren(span);
}

function removeMoreResultsLinks() {
	var aTags = getElementsByTagAndClass("a", "scMoreResults");
	var i;
	for (i = 0; i < aTags.length; i++) {
		try {
			var aTag = aTags[i];
			aTag.parentNode.removeChild(aTag);
		} catch (e) {}
	}
}

// Describes the average height of the '#web' div in px,
// it's statically sized through a mechanism I don't understand,
// and therefore needs to be forcefully expanded in order for
// page 2 to be visible
function expandYahooShoppingWrapperDiv(addedNode) {
	if (!onYahooShoppingGridView()) {
		return;
	}

	var webWrapper = getById('web');
	if (!webWrapper) {
		return;
	}

	var height = yahooShoppingNodeHeight(webWrapper);
	height = height.toString() + 'px';
	webWrapper.style.height = height;
}

function yahooShoppingNodeHeight(addedNode) {
	var nodeHeight = 0;

	// calc size of displayed rows
	var nodes = addedNode.getElementsByTagName('li');
	var numRows = nodes.length / 4;
	numRows += (nodes.length % 4 > 0 ? 1 : 0);
	nodeHeight = nodes[0].clientHeight * numRows;

	// calc size of separators
	nodes = addedNode.getElementsByTagName('center');
	nodeHeight += (nodes.length * 50);

	return nodeHeight;
}

function insertMoreResults(text) {
	var insertPoint = getById('scInsertPoint');

	if (scIsFF && isMZ(SC.partner)) {
		var xmlRoot = scXmlParser(text);
		var data = xmlRoot.getElementsByTagName('data')[0];
		text = scGetText(data.getElementsByTagName('recs')[0]);
	}

	appendSafeHtml(text, function(html) {
		insertPoint.innerHTML = html;
		updateAttributesAfterUi(data);
	});

	installSCClickHandlers(insertPoint);

	if (scIsOldIE) {
		insertPoint.scrollIntoView();
	}

	if (onYahooShoppingGridView()) {
		YSGridRows.initRows();
	}

	insertPoint.id = '';
}

function duplicatePageReceivedFromServer(text) {
	var pageNum;
	for (pageNum = 99; pageNum >= 0; pageNum--) {
		var nodeId = 'scPageSeparator' + pageNum;
		if (getById(nodeId)) {
			if (text.indexOf(nodeId) >= 0) {
				return true;
			}
			break;
		}
	}

	return false;
}

function moreResults() {
	if (SC.gettingMoreResults) {
		return;
	}

	SC.gettingMoreResults = true;
	if (getById('scInsertPoint')) {
		var url = SC.host + 'search/moreResults?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&now=' + scGetTime() + SC.useGridView;
		sc_ajax({
			method : 'GET',
			url : url,
			onload : function (xhr) {
				try {
					var text = getResponseText(xhr);
					if (isOkServerResponse(text)) {
						if ((text.length > 10) && !duplicatePageReceivedFromServer(text)) {
							insertMoreResults(text);

							SC.srSelectionCount = 0;
							uploadMoreSRs();

							if (contains(text, '<!--NO_MORE_RESULTS-->')) {
								removeMoreResultsLinks();
							}

							var pageNum;
							for (pageNum = 99; pageNum >= 0; pageNum--) {
								var nodeId = 'scPageSeparator' + pageNum;
								if (getById(nodeId)) {
									focusOnNode(nodeId);
									break;
								}
							}
						}
					} else {
						handleConnectionError('moreResults1', url);
					}
				} catch (e) {
					log('error getting more results: ' + e.message);
				}
				finally {
					SC.gettingMoreResults = false;
				}
			},
			onerror : function () {
				SC.gettingMoreResults = false;
				handleConnectionError('moreResults2', url);
			}
		});
	}
}

function goToPage(start) {
	if (SC.goingToPage) {
		return;
	}

	SC.goingToPage = true;
	if (getById('scInsertPoint')) {
		var url = SC.host + 'search/goToPage?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&start=' + start + '&now=' + scGetTime() + SC.useGridView;
		sc_ajax({
			method : 'GET',
			url : url,
			onload : function (xhr) {
				try {
					var text = getResponseText(xhr);
					if (isOkServerResponse(text)) {
						if ((text.length > 10) && !duplicatePageReceivedFromServer(text)) {
							var newPageNum = Math.round(start / getNumResultsPerPage()) + 1;
							insertMoreResults(text);

							SC.srSelectionCount = 0;
							uploadMoreSRs();

							focusOnNode('scPageSeparator' + newPageNum);
						}
					} else {
						handleConnectionError('goToPage1', url);
					}
				} catch (e) {
					log('error going to page: ' + e.message);
				}
				finally {
					SC.goingToPage = false;
				}
			},
			onerror : function () {
				SC.goingToPage = false;
				handleConnectionError('goToPage2', url);
			}
		});
	}
}

function isSecondGoogleSearchButtonClick() {
	var now = scGetTime();
	var ts = getGoogleSearchButtonClickTimestamp();
	var query = getGoogleSearchButtonClickQuery();
	var rtn = false;
	if (!ts) {
		setGoogleSearchButtonClickTimestamp(now);
		setGoogleSearchButtonClickQuery(SC.query);
	} else {
		var diff = now - ts;
		if (diff > 99) {
			setGoogleSearchButtonClickTimestamp(now);
			setGoogleSearchButtonClickQuery(SC.query);
			rtn = (query == SC.query);
		}
	}

	return rtn;
}

function resetSearchSessionAndResetPage() {
	sc_ajax({
		method : 'GET',
		url : SC.host + 'search/reset?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion,
		onload : function (xhr) {
			SC.forceReinvokeExtensionInit = true;
			resetPage();
		},
		onerror : function () {
			SC.forceReinvokeExtensionInit = true;
			resetPage();
		}
	});
}

function resetPage() {
	SC.srSelectionCount = 0;
	var i;

	for (i = 0; i < scSRNodes.length; i++) {
		var srNode = scSRNodes[i];
		var url = SERP.extractUrlFromSRNode(srNode);
		if (url) {
			var urlHash = getUrlHash(url);
			var span = getRecsSpan(urlHash);
			removeChildren(span);
		}
	}

	var originalInsertPoint = getElementsByTagAndAttribute("div", "scOriginalInsertPoint", "1")[0];
	removeChildren(originalInsertPoint);
	originalInsertPoint.setAttribute('id', 'scInsertPoint');
}

function getUrlHashFromNode(node) {
	var urlHash;
	while (node && node.getAttribute) {
		if (!urlHash) {
			urlHash = node.getAttribute('scUrlHash');
		}

		node = node.parentNode;
	}

	return urlHash;
}

function closeRecsClickHandler(event) {
	try {
		cancelEvent(event);
		var node = scIsIE ? event.srcElement : event.target;

		var urlHash = getUrlHashFromNode(node);
		closeRecs(urlHash);
	} catch (e) {}
}

function installSCClickHandler(node, func) {
	if (!node) {
		node = document;
	}

	if (!func && onSerpThatSupportsReranking()) {
		func = clickHandler;
		if (scIsOldIE) {
			onmouseup = function () {
				clickHandler(window.event);
			};
		}
	}

	if (node && func) {
		// use a hash code to prevent the same handler being installed
		// more than once on the same node
		var hashCode = node.nodeName + node.nodeType + func.toString().length;
		if (!SC.clickHandlers[hashCode]) {
			SC.clickHandlers[hashCode] = 1;
			if (scIsOldIE) {
				node.attachEvent('onmouseup', func);
			} else {
				node.addEventListener('click', func, true);
			}
		}
	}
}

function uninstallSCClickHandler(node, func) {
	if (!node) {
		node = document;
	}

	if (!func && onSerpThatSupportsReranking()) {
		func = clickHandler;
		if (scIsOldIE) {
			onmouseup = function () {};
		}
	}

	if (node && func) {
		// use a hash code to prevent the same handler being installed
		// more than once on the same node
		var hashCode = node.nodeName + node.nodeType + func.toString().length;
		if (SC.clickHandlers[hashCode]) {
			SC.clickHandlers[hashCode] = 0;
			if (scIsOldIE) {
				node.detachEvent('onmouseup', func);
			} else {
				node.removeEventListener('click', func, true);
			}
		}
	}
}

function installSCClickHandlers(node) {
	var imgs = getElementsByTagAndClass("img", "scClose");
	var i,
	len = imgs.length;
	for (i = 0; i < len; i++) {
		installSCClickHandler(imgs[i], closeRecsClickHandler);
	}
}

function clickHandler(event) {
	try {
		if (!onSerpThatSupportsReranking()) {
			return;
		}

		var ready = true;
		if (SC.uploadResults && (!SC.firstBatchReceived && !SC.continuingSession)) {
			SC.bufferedEvent = scIsIE ? new EventRecord(event) : event;
			ready = false;
		}

		var node = scIsIE ? event.srcElement : event.target;

		var parentNode = node.parentNode;
		var tagName = node.tagName;
		if (!tagName) {
			tagName = node.getAttribute('tagName');
		}
		var className = node.className;
		if (!className) {
			className = node.getAttribute('class');
		}

		var rightClick;
		if (event.which) {
			rightClick = (event.which === 3);
		} else if (event.button) {
			rightClick = (event.button === 2);
		}

		if (className) {
			if (className == 'scMoreResults') {
				moreResults();
				cancelEvent(event);
				return;
			}
		}

		var isGoogleSearchButton = onGoogleSerp() && (tagName == 'INPUT') && (className == 'lsb');
		if (isGoogleSearchButton) {
			if (isSecondGoogleSearchButtonClick()) {
				resetSearchSessionAndResetPage();
			} else {
				SC.forceReinvokeExtensionInit = true;
			}
			return;
		}

		var url;
		var urlHash;
		var isInLink = false;
		var aTagNode;
		var isNextPageLink = false;
		var gotoPageStartVal = 0;
		while (node && node.getAttribute) {
			if (!isInLink) {
				var text = node.toString();
				isInLink = (startsWith(text, 'http') || startsWith(text, 'ftp'));
				if (isInLink) {
					url = text;
				}
			}

			var id = '';
			try {
				id = node.getAttribute('id');
			} catch (e) {}

			if (id == 'scRemoveRefinements') {
				return removeRefinements();
			}

			if (!urlHash) {
				urlHash = node.getAttribute('scUrlHash');
			}

			if (!(isNextPageLink || gotoPageStartVal) && (node.tagName == 'A')) {
				try {
					var linkType = determineLinkType(node);
					if (linkType == 'Next') {
						isNextPageLink = true;
					} else if (linkType == 'Goto') {
						gotoPageStartVal = node.getAttribute('scGotoPageStartVal');
					}
				} catch (e) {
					log(e.message);
				}
				aTagNode = node;
			}

			node = node.parentNode;
		}

		if (isNextPageLink) {
			cancelEvent(event);
			if (ready) {
				moreResults();
				SC.numUserActions++;
			}
			return;
		} else if (gotoPageStartVal) {
			cancelEvent(event);
			if (ready) {
				goToPage(gotoPageStartVal);
				SC.numUserActions++;
			}
			return;
		}

		var clickedLink = (tagName == 'A' || isInLink);
		var clickedLinkFromSerp = clickedLink && SC.searchEngine;
		var openNewWindow = linkClickOpensNewWindow(event);
		if (urlHash) {
			if (clickedLinkFromSerp) {
				getRecs(urlHash, ready && (rightClick || openNewWindow), rightClick ? 'rightClick' : 'click', openNewWindow);
				var span = getRecsSpan(urlHash);
				if (span) {
					incNumResultsClicked();

					if (SC.numUserActions > 0) {
						incNumResultsClickedWhenRecsAvailable();
					}
					SC.numUserActions++;

					if (span.getAttribute('srType') == 'rec') {
						incNumRecsClicked();
					}
				}
			}
		} else if (clickedLinkFromSerp && url) {
			sc_ajax({
				method : 'GET',
				url : SC.host + 'search/linkClick?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&url=' + encodeURIComponent(url) + '&openNewWindow=' + (openNewWindow ? '1' : '0')
			});
		}
	} catch (e) {
		log('error in click handler: ' + e.message);
	}
}

function removeProtocol(url) {
	var pos = url.indexOf('://');
	if (pos != -1) {
		url = url.substring(pos + 3);
	}
	return url;
}

function getUrlHash(url) {
	var urlHash = '';

	if (url) {
		url = decodeEntities(url);

		var len = url.length,
		i;
		for (i = 0; i < len; i++) {
			var c = url.charAt(i);
			if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') || (c >= '0' && c <= '9') || (c == '-') || (c == '_')) {
				urlHash += c;
			}
		}
	}
	return urlHash;
}

function handleConnectionError(where, url) {
	log('error in ' + where);
	var navbar = getNavbar();

	var nodes = getChildrenByTagName(navbar, 'a');
	var i;
	for (i = 0; i < nodes.length; i++) {
		restoreHref(nodes[i]);
	}

	if (scIsOldIE) {
		document.detachEvent('onmouseup');
	} else {
		document.removeEventListener('click', clickHandler, true);
	}
}

function focusOnNode(id) {
	var nodeToFocus = getById(id);
	if (nodeToFocus) {
		nodeToFocus.scrollIntoView();
	}
}

function insertYahooShoppingGridRecsDivs() {
	var nodes = getElementsByTagAndClass('li', 'row-last');
	for (var i = 0; i < nodes.length; i++) {
		var srNode = scSRNodes[i];
		var url = SERP.extractUrlFromSRNode(srNode);
		var attrVal = srNode.getAttribute('scUrlHash');

		if (url && !attrVal) {
			var urlHash = getUrlHash(url);
			srNode.setAttribute('scUrlHash', urlHash);

			var recsDiv = make('div');
			recsDiv.id = 'scRecs' + urlHash;
			recsDiv.style.marginLeft = '210px';

			srNode.parentNode.insertBefore(recsDiv, srNode.nextSibling);
		}
	}
	return getById('web');
}

function insertRecsSpans(isGoogle) {
	var srContainer,
	i;
	for (i = 0; i < scSRNodes.length; i++) {
		try {
			var srNode = scSRNodes[i];
			var url = SERP.extractUrlFromSRNode(srNode);
			var attrVal = srNode.getAttribute('scUrlHash');
			var isGoogleStarSection = isGoogle && contains(srNode.innerHTML, 'href="/bookmarks/find?');
			if (url && !attrVal && !isGoogleStarSection) {
				var urlHash = getUrlHash(url);
				srNode.setAttribute('scUrlHash', urlHash);

				var recsSpan = make('span');
				recsSpan.setAttribute('id', 'scRecs' + urlHash);
				recsSpan.setAttribute('scIsOrganicResult', 1);
				srNode.appendChild(recsSpan);

				if (!srContainer) {
					srContainer = isGoogle ? srNode.parentNode.parentNode : srNode.parentNode;
				}
			}
		} catch (e) {
			log(e.message);
		}
	}
	return srContainer;
}

function initUI() {
	var isGoogle = onGoogleSerp();

	var srContainer = onYahooShoppingGridView() ? YSGridRows.initRows() : insertRecsSpans(isGoogle);

	if (srContainer) {
		var div = make('div');
		div.setAttribute('id', 'scInsertPoint');
		div.setAttribute('scOriginalInsertPoint', '1');
		srContainer.appendChild(div);
	}

	if (!getAllDisabled() && !(isGoogle && isWTI(SC.partner))) {
		interceptMoreResultsLinks();
	}

	if (isGoogle) {
		// prevent recs from bleeding into east content
		addPageStyle('h3.r { white-space: normal !important; word-break: hyphenate; } #res h3.r { white-space: normal !important; word-break: hyphenate; }');
	}

	if (onTestServer()) {
		try {
			YSShoppingBlock = getShoppingBlockFactory();
		} catch (e) {
		}
	}
}

function updateUIAfterRefresh(data) {
	if (getAllDisabled()) {
		return;
	}
	initUI();

	var srXmlNodes = data.getElementsByTagName('sr');
	var i;
	for (i = 0; i < srXmlNodes.length; i++) {
		var srXmlNode = srXmlNodes[i];
		var urlHash = scGetText(srXmlNode.getElementsByTagName('urlHash')[0]);
		var srNode = getSRByUrlHash(urlHash);
		if (srNode) {
			var recs = srXmlNode.getElementsByTagName('recsHtml')[0];
			var updateAttrs = (i == (srXmlNodes.length - 1));
			updateRecsInUI(urlHash, recs, data, updateAttrs);
		}
	}

	var moreResultsHtml = scGetText(data.getElementsByTagName('moreResults')[0]);
	var originalInsertPoint = getElementsByTagAndAttribute("div", "scOriginalInsertPoint", "1")[0];
	if (moreResultsHtml && originalInsertPoint) {

		appendSafeHtml(moreResultsHtml, function(html) {
			originalInsertPoint.innerHTML = html;
			originalInsertPoint.id = '';
			updateAttributesAfterUi(data);
		});

	}

	if (!scIsFF) {
		focusOnNode("scFocus");
	}


}

function renderYahooAd(node, urlHash, url, displayUrl, title, snippet, addBr) {
	if (urlHash && url && displayUrl && title && snippet) {
		var main = make('div');
		main.setAttribute('scUrlHash', urlHash);

		var tag = make('a');
		tag.setAttribute('href', url);
		tag.setAttribute('target', '_blank');
		tag.textContent = title;
		main.appendChild(tag);
		main.appendChild(make('br'));
		tag = make('div');
		tag.style.color = 'green';
		tag.style.marginTop = '2px';
		tag.style.marginBottom = '-16px';
		tag.textContent = displayUrl;
		main.appendChild(tag);
		main.appendChild(make('br'));
		tag = make('div');
		tag.textContent = snippet;
		main.appendChild(tag);

		var recsSpan = make('div');
		recsSpan.setAttribute('id', 'scRecs' + urlHash);
		main.appendChild(recsSpan);

		node.appendChild(main);

		if (addBr) {
			node.appendChild(make('br'));
		}
	}
}


function refreshDynamicContent() {
	if (SC.refreshingDynamicContent || getAllDisabled()) {
		return;
	}

	SC.refreshingDynamicContent = true;
	var url = SC.host + 'search/refresh?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + SC.useGridView;
	sc_ajax({
		method : 'GET',
		url : url,
		onload : function (xhr) {
			try {
				var text = getResponseText(xhr);
				if (isOkServerResponse(text)) {
					var xmlRoot = scXmlParser(text);
					var data = xmlRoot.getElementsByTagName('data')[0];
					if (data) {
						var userStatusNode = data.getElementsByTagName('userStatus')[0];
						scUserStatus = userStatusNode ? scGetText(userStatusNode) : "";

						node = data.getElementsByTagName('notEnoughResults')[0];
						if (scGetText(node) != '1') {
							updateUIAfterRefresh(data);
						}
					}
				} else {
					handleConnectionError('refresh1', url);
				}
			} catch (e) {
				log('error in refresh: ' + e.message);
			}
			finally {
				SC.refreshingDynamicContent = false;
			}
		},
		onerror : function () {
			SC.refreshingDynamicContent = false;
			handleConnectionError('refresh2', url);
		}
	});
}

function pageshowHandler(event) {
	if ((typeof event !== "undefined") && (typeof event.persisted !== "undefined") && event.persisted) {
		installSCClickHandler();
		refreshDynamicContent();
	}
}

function pagehideHandler(event) {
	if ((typeof event !== "undefined") && (typeof event.persisted !== "undefined") && event.persisted) {
		uninstallSCClickHandler();
	}
}

function customizePageKeyHandler(event) {
	if (event.keyCode == 116) {
		event.keyCode = 0;
		event.returnValue = false;
		updateCustomizePage();
	}
}

function customizePageClickHandler(event) {
	try {
		var node = scIsIE ? event.srcElement : event.target;
		var id = node.getAttribute('id');
		if (startsWith(id, 'save')) {
			saveCustomizePage();
		} else {
			switch (id) {
			case 'disableOdometer':
				setOdometerDisabled(true);
				updateCustomizePage();
				break;
			case 'enableOdometer':
				setOdometerDisabled(false);
				updateCustomizePage();
				break;
			case 'resetOdometer':
				clearNumSearches();
				clearNumResultsClicked();
				clearNumResultsClickedWhenRecsAvailable();
				clearNumRecsClicked();
				updateCustomizePage();
				break;
			}
		}
	} catch (e) {}
}

function setCustomizePageCheckbox(divName, val) {
	try {
		getById(divName).checked = val;
	} catch (e) {}
}

function updateCustomizePage() {
	try {
		var checkboxes = getElementsByTagAndAttribute("input", "type", "checkbox");
		for (i = 0; i < checkboxes.length; i++) {
			checkboxes[i].checked = false;
		}

		setCustomizePageCheckbox('enableAll', !getAllDisabled());

		setCustomizePageCheckbox('showRecsOnSRClick', getShowRecsOnSRClick());
		getById('maxRecs').value = getMaxNumRecsForSRSelection();
		setCustomizePageCheckbox('addRefinements', getRefinementLinksEnabled());
		setCustomizePageCheckbox('addSearchLinks', getSearchLinksEnabled());
		setCustomizePageCheckbox('addRoamingSuggestions', getRoamingSuggestionsEnabled());
		setCustomizePageCheckbox('displaySimilarProductImages', getDisplaySimilarProductImages());

		getById('odometerNumSearches').textContent = getNumSearches();
		getById('odometerNumResultsClicked').textContent = getNumResultsClicked();
		getById('odometerNumResultsClickedWhenRecsAvailable').textContent = getNumResultsClickedWhenRecsAvailable();
		getById('odometerNumRecsClicked').textContent = getNumRecsClicked();
		getById('odometerSearchBoost').textContent = getSearchBoost();

		if (getOdometerDisabled()) {
			getById('disableOdometer').style.display = 'none';
			getById('enableOdometer').style.display = 'block';
		} else {
			getById('disableOdometer').style.display = 'block';
			getById('enableOdometer').style.display = 'none';
		}

		if (SC.partner.toLowerCase() == 'yhoo') {
			removeChildren(getById('other'));

		}
	} catch (e) {}
}

function isCheckedOnCustomizePage(divName) {
	var b;
	try {
		b = getById(divName).checked;
	} catch (e) {}
	return b;
}

function saveCustomizePage() {
	setAllDisabled(!isCheckedOnCustomizePage('enableAll'));

	setShowRecsOnSRClick(isCheckedOnCustomizePage('showRecsOnSRClick'));
	setMaxNumRecsForSRSelection(getById('maxRecs').value);
	setRefinementLinksEnabled(isCheckedOnCustomizePage('addRefinements'));
	setSearchLinksEnabled(isCheckedOnCustomizePage('addSearchLinks'));
	setRoamingSuggestionsEnabled(isCheckedOnCustomizePage('addRoamingSuggestions'));
	setDisplaySimilarProductImages(isCheckedOnCustomizePage('displaySimilarProductImages'));

	alert('Your preferences have been saved.');
}

function updateDynamicPreferences() {
	if (getAllDisabled()) {
		return;
	}

	var now = scGetTime();
	var timestamp = getDynamicPreferencesTimestamp() || 0;
	var checkInterval = 24 * 60 * 60 * 1000; // one day
	if (now - timestamp > checkInterval) {
		setDynamicPreferencesTimestamp(now);
		sc_ajax({
			method : 'GET',
			url : SC.host + 'dynamic_preferences.jsp',
			onload : function (xhr) {
				var text = getResponseText(xhr);
				if (isOkServerResponse(text)) {
					var xmlRoot = scXmlParser(text);
					var settings = xmlRoot.getElementsByTagName('settings')[0];
					processDynamicPreferencesSettings(settings);
				}
			}
		});
	}
}

function processDynamicPreferencesSettings(settings) {
	try {
		var nodes = settings.getElementsByTagName('setting');
		var i;
		for (i = 0; i < nodes.length; i++) {
			var setting = nodes[i];
			processSetting(setting);
		}
	} catch (e) {
		log(e.message);
	}
}

function processSetting(setting) {
	var setpref = setting.getElementsByTagName('setpref')[0];
	var prefName = setpref.getAttribute('name');

	var isMatch = allConditionsMet(setting);
	if (isMatch) {
		var matchValue = setpref.getAttribute('matchvalue');
		setDynamicPreference(prefName, matchValue);
	} else {
		var nomatchValue = setpref.getAttribute('nomatchvalue');
		setDynamicPreference(prefName, nomatchValue);
	}
}

function setDynamicPreference(prefName, value) {
	try {
		if (value === '0' || value === 'false') {
			setBoolPreferenceValue(prefName, false);
		} else if (value === '1' || value === 'true') {
			setBoolPreferenceValue(prefName, true);
		} else if ((value !== null) && (value !== undefined)) {
			setCharPreferenceValue(prefName, value);
		}
	} catch (e) {}
}

function allConditionsMet(setting) {
	var nodes = setting.getElementsByTagName('condition');
	var i;
	for (i = 0; i < nodes.length; i++) {
		var condition = nodes[i];
		var value = getConditionValue(condition);
		var regex = condition.getAttribute('regex');
		if (!(new RegExp(regex, 'i')).test(value)) {
			return false;
		}
	}

	return true;
}

function getConditionValue(condition) {
	var value = '';

	var src = condition.getAttribute('src');
	if (src === 'extension_version') {
		value = SC.extensionVersion;
	} else if (src === 'user_agent') {
		value = navigator.userAgent;
	} else {
		value = getCharPref(src);
	}

	// convert value to a string
	if (!value) { // handle value === null, undefined or false
		value = '';
	} else if (value === true) {
		value = 'true';
	}

	var end = condition.getAttribute('end');
	if (end) {
		value = value.substring(0, end);
	}

	var start = condition.getAttribute('start');
	if (start) {
		value = value.substring(start);
	}

	return value;
}

function onGoogleSerp() {
	var args = window.location.search;
	var path = window.location.pathname;
	var isGoogleSearchDomain = (contains(SC.currentDomain, '.google.') && (contains(SC.currentDomain, 'www') || contains(SC.currentDomain, 'encrypted')));
	var isWtiPageN = isWTI(SC.partner) && getPageUrl().match(/&start=[1-9]/);
	return (isGoogleSearchDomain && !isWtiPageN && ((path == '/') || (path == '/search') || (path == '/webhp')) && !contains(args, 'define%3A') && !contains(args, '&tbs=frim'));
}

function onYahooSerp() {
	return contains(SC.currentDomain, 'search.yahoo.com') && !contains(SC.currentDomain, 'video.search.') && !contains(SC.currentDomain, 'images.search.') && !contains(SC.currentDomain, 'news.search.') && !contains(SC.currentDomain, 'shopping.search.');
}

function onYahooShopping() {
	return contains(SC.currentDomain, 'shopping.search.yahoo.com') || ((onTestServer()) && contains(SC.currentDomain, 'shopping.yahoo.com'));
}

function onYahooShoppingGridView() {
	return (onYahooShopping()) && contains(window.location.search, 'section=grid');
}

function onSerpThatSupportsReranking() {
	return (onGoogleSerp() || onYahooSerp() || onYahooShopping());
}

function onSCWebSitePage(bodyId) {
	var b = false;

	if (onSCPage()) {
		try {
			b = (document.body.id == bodyId);
		} catch (e) {}
	}

	return b;
}

function isSC(partner) {
	return partner && startsWith(partner.toUpperCase(), 'SC');
}

function isAI(partner) {
	return partner && startsWith(partner.toUpperCase(), 'AI');
}

function isAPS(partner) {
	return partner && startsWith(partner.toUpperCase(), 'APS');
}

function isFromPadFile(partner) {
	return partner && endsWith(partner.toUpperCase(), 'PAD');
}

function isMZ(partner) {
	return partner && startsWith(partner.toUpperCase(), 'MZ');
}

function isWTI(partner) {
	return partner && startsWith(partner.toUpperCase(), 'WTI');
}

function isWTIUS(partner) {
	return isWTI(partner) && contains(partner.toUpperCase(), 'US');
}

function isSpecialPartner(partner) {
	return isAI(partner) || isAPS(partner) || isWTI(partner) || isFromPadFile(partner);
}

function searchLinksTermList() {
	var terms = ['airline', 'accident attorney', 'annuity settlement', 'apparel', 'auto donation', 'auto title loan', 'bipolar', 'blu-ray', 'business bank account', 'camcorder', 'camera', 'clothes', 'clothing', 'conference call service', 'consolidating debt', 'cosmetic', 'coupon', 'data room', 'dedicated hosting', 'depression', 'digital marketing course', 'digital marketing degree', 'dvd', 'electronics', 'erectile dysfunction', 'flight', 'footwear', 'fragrance', 'gaming system', 'halo', 'hdtv', 'home alarm', 'home theater', 'imac', 'injury attorney', 'insomnia', 'insurance quotes', 'ipad', 'iphone', 'ipod', 'jailbreak', 'jeans', 'kindle', 'kinect', 'laptop', 'lenovo', 'levitra', 'lipitor', 'macbook', 'medical billing software', 'mortgage', 'netbook', 'nintendo ds', 'nintendo dsi', 'online college', 'online forex broker', 'online gold trading', 'online marketing course', 'online marketing degree', 'paralegal training', 'perfume', 'pet med', 'playstation 3', 'ps3', 'refinance', 'reverse mortgage lender', 'ringtone', 'server monitoring software', 'shoe', 'slr', 'software asset management', 'tadalafil', 'tax attorney', 'tax debt relief', 'tax help', 'tax levy', 'telemarketing software', 'transfer credit card', 'video game', 'video hosting', 'web design training', 'webcam', 'webpage monitoring', 'wii', 'xbox'];

	var refSets = getCachedRefinements().split('^');
	var i, j, len = refSets.length;
	for (i = 0; i < len; i++) {
		var refSet = refSets[i];
		if (refSet) {
			var arr = refSet.split('/');
			var query = arr[0];
			var refs = arr[1];

			var refsArray = refs.split(':');
			for (j = 0; j < refsArray.length; j++) {
				var ref = refsArray[j];
				if ((ref.length > 2) && (ref != query)) {
					addToArrayWithNoDups(terms, query + '/' + ref);
				}
			}
			addToArrayWithNoDups(terms, query);
		}
	}

	return terms;
}

function clientSideSearchLinks() {
	scSearchLinksInvocationTimestamp = scGetTime();

	try {
		var terms = searchLinksTermList();

		var textNodes = [];
		addTextNodesToArray(document.body, textNodes);
		addSearchLinks(terms, textNodes, 'c');
	} catch (e) {
		log(e.message);
	}

	if (onFacebookPage()) {
		setTimeout(function () {
			clientSideSearchLinks();
		}, 10000);
	}
}

function addToArrayWithNoDups(arr, item) {
	var i = arr.length;
	while (i--) {
		if (arr[i] === item) {
			return;
		}
	}
	arr.push(item);
}

function addTextNodesToArray(node, arr) {
	if (node) {
		var children = node.childNodes;
		var numChildren = children.length;
		if ((node.nodeType === 3) && (numChildren === 0)) {
			var text = node.data;
			if (text && (text.length > 25)) {
				arr.push(node);
			}
		} else {
			var i;
			for (i = 0; i < numChildren; i++) {
				var child = children[i];
				var tagName = child.tagName;
				var isProhibitedTag = tagName && ((tagName === 'A') || (tagName === 'META') || (tagName === 'FORM') || (tagName === 'LABEL') || (tagName === 'SCRIPT') || (tagName === 'STYLE') || (tagName === 'OPTION') || (tagName === 'BUTTON') || (tagName === 'INPUT') || (tagName === 'TEXTAREA') || (tagName === 'H1') || (tagName === 'H2') || (tagName === 'H3'));
				if (!isProhibitedTag) {
					addTextNodesToArray(child, arr);
				}
			}
		}
	}
}

function addSearchLinks(terms, textNodes, slType) {
	// recursively "loop" over terms, calling processSearchLinksTerm() on each term.
	// since this may be slow, use setTimeout to yield the CPU between loop iterations.
	if (terms.length) {
		processSearchLinksTerm(terms.pop(), textNodes, slType);

		// the previous line shortened the terms list by 1. if we still have more
		// terms, then recurse. otherwise, we're done, so call viglink.
		if (terms.length && (scGetTime() - scSearchLinksInvocationTimestamp < 9999)) {
			setTimeout(function () {
				addSearchLinks(terms, textNodes, slType);
			}, 15);
		} else {
			addVigLink();
		}
	}
}

function isCompany(term) {
	term = term.toLowerCase();
	return (term === 'amazon') || (term === 'apple') || (term === 'bing') || (term === 'blogspot') ||
	(term === 'ebay') || (term === 'facebook') || (term === 'gmail') || (term === 'google') ||
	(term === 'hotmail') || (term === 'linkedin') || (term === 'microsoft') || (term === 'pinterest') ||
	(term === 'quora') || (term === 'tumblr') || (term === 'twitter') || (term === 'wikipedia') ||
	(term === 'wordpress') || (term === 'yahoo') || (term === 'yandex') || (term === 'youtube');
}

function processSearchLinksTerm(term, textNodes, slType) {
	if (term && !isCompany(term)) {
		var numTextNodes = textNodes.length,
		i;
		for (i = 0; i < numTextNodes; i++) {
			var textNode = textNodes[i];
			var added = addSearchLinksToNode(term, textNode, slType);
			if (added) {
				break;
			}
		}
	}
}

function addSearchLinksToNode(term, textNode, slType) {
	var parentNode = textNode.parentNode;
	if (!parentNode) {
		return;
	}

	var queryFromRefinement;
	if (contains(term, '/')) {
		var arr = term.split('/');
		queryFromRefinement = arr[0];
		term = arr[1];
	}

	if (isStopWord(term)) {
		return;
	}

	if (queryFromRefinement && !contains(textNode.data.toLowerCase(), queryFromRefinement)) {
		return;
	}

	var matches = (new RegExp('\\b' + term + '[s]?\\b', 'i')).exec(textNode.data);
	if (matches) {
		var text = matches[0];
		var before = matches.input.substring(0, matches.index);
		var after = matches.input.substring(matches.index + text.length);
		text = text.replace(/\s+/g, " ");
		textNode.data = before;

		var query = (queryFromRefinement && !contains(text.toLowerCase(), queryFromRefinement)) ? (queryFromRefinement + ' ' + text) : text;
		var url = constructDestinationSiteUrl(query, 'sl' + slType);

		var aTag = make('a');
		aTag.setAttribute('href', url);
		aTag.setAttribute('target', 'scSearchLink');
		aTag.style.textDecoration = 'none';
		aTag.style.borderBottom = 'dotted';
		aTag.textContent = text;
		parentNode.insertBefore(aTag, textNode.nextSibling);

		var textNode2 = document.createTextNode(after);
		parentNode.insertBefore(textNode2, aTag.nextSibling);

		return 1;
	}
}

function constructDestinationSiteUrl(query, f) {
	var partner = SC.partner ? SC.partner.toLowerCase() : 'sc';
	return SC.host + 'search?q=' + encodeURIComponent(query) + '&f=' + f + '&p=' + partner;
}

function initNewFFInstallation() {
	var lastSeenSplash = getLastSeenSplash();
	var isNewInstall = !lastSeenSplash;

	SC.instId = getInstId();
	SC.partner = getPartner();

	SC.instTimestamp = getInstTimestamp();
	var versionNoDots = SC.extensionVersion.replace(/\./g, '');

	if (isNewInstall) {
		setLastSeenSplash(versionNoDots);

		sc_ajax({
			method : 'GET',
			url : SC.host + 'newInstall?p=' + SC.partner
		});
	} else if (lastSeenSplash && (lastSeenSplash !== versionNoDots)) {
		var displaySplashPage = 0; // value dynamically set in build.xml
		if (displaySplashPage) {
			setLastSeenSplash(versionNoDots);
			var splashUrl = SC.host + 'newInVersion' + versionNoDots + '.jsp';
			openNewTab(splashUrl);
		}
	}
}

function createGlobalData() {
	try {
		SC = {
			host : 'http://www.surfcanyon.com/',
			extensionVersion : '5.4.0'
		};

		if (scIsIE) {
			initIE();
		} else if (scIsChrome) {
			initChrome();
		} else if (scIsSafari) {
			initSafari();
		} else if (scIsFF) {
			initFF();

			// initNewFFInstallation requires SC.host and SC.extensionVersion to be set
			initNewFFInstallation();
		}

		// set prefs on first run. on IE, this needs to be after the initIE() call.
		var max = getCharPref("max_num_recs");
		if (!max) {
			setMaxNumRecsForSRSelection('3');
			setShowRecsOnSRClick(true);
		}

		// this section needs to be after initNewFFInstallation, since it initializes
		// these variables the first time the extension runs.
		mergeProperties(SC, {
			instId : getInstId(),
			instTimestamp : getInstTimestamp(),
			partner : getPartner()
		});

		if (typeof SC.currentDomain === 'undefined') {
			try {
				SC.currentDomain = window.location.host;
			} catch (e) {}
		}

		if (typeof SC.currentUrl === 'undefined') {
			try {
				SC.currentUrl = window.location.href;
			} catch (e) {}
		}

		if (typeof SC.currentTitle === 'undefined') {
			try {
				SC.currentTitle = document.title;
			} catch (e) {}
		}

		mergeProperties(SC, {
			searchEngine : null,
			query : null,
			prevQuery : null,
			queryChanged : false,
			queryChangedPrev : false,
			bufferedEvent : null,
			uploadResults : false,
			firstBatchReceived : false,
			continuingSession : false,
			gettingRecs : false,
			gettingMoreResults : false,
			goingToPage : false,
			refreshingDynamicContent : false,
			numUserActions : 0,
			srSelectionCount : 0,
			batchNum : 0,
			numBatchesLeftToUpload : 0,
			forceReinvokeExtensionInit : false,
			originalNavBar : null,
			originalNavBar2 : null,
			clickHandlers : [],
			useGridView : onYahooShoppingGridView() ? "&gridView=1" : ""
		});
	} catch (e) {}
}

function initializeBooleanPreference(basePrefName, initialValue) {
	try {
		var prefName = basePrefName + '_enabled';
		var prefInitedName = 'initialized_' + basePrefName;
		if (!getBoolPreferenceValue(prefInitedName)) {
			setBoolPreferenceValue(prefName, initialValue);
			setBoolPreferenceValue(prefInitedName, true);
		}
	} catch (e) {
		log(e.message);
	}
}

function injectSuperfish() {
	try { // NO_MOZ
		if (document.body) { // NO_MOZ
			var script = make("script"); // NO_MOZ
			script.type = "text/javascript"; // NO_MOZ
			script.src = "http://www.superfish.com/ws/sf_main.jsp?dlsource=surfcanyon&userId=" + SC.instId + "&CTID=" + SC.partner; // NO_MOZ
			getTags("head")[0].appendChild(script); // NO_MOZ
		} // NO_MOZ
	} catch (e) {} // NO_MOZ
}

function injectPredictAd() {
	try { // NO_MOZ
		if (document.body && (document.defaultView.top == document.defaultView.self)) { // NO_MOZ
			var script = make("script"); // NO_MOZ
			script.type = "text/javascript"; // NO_MOZ
			script.src = "http://cdn1.certified-apps.com/scripts/shared/enable.js?si=19269"; // NO_MOZ
			getTags("body")[0].appendChild(script); // NO_MOZ
		} // NO_MOZ
	} catch (e) {} // NO_MOZ
}

function setup() {
	try {
		createGlobalData();
		if (typeof SC.currentDomain === 'undefined') {
			return;
		}

		installSCClickHandler();

		if (isSpecialPartner(SC.partner)) {
			initializeBooleanPreference('display_similar_product_images', true);
			initializeBooleanPreference('refinement_links', true);
			initializeBooleanPreference('roaming_suggestions', true);
			initializeBooleanPreference('search_links', true);
			initializeBooleanPreference('ss_page_links', true);
		} else if (isMZ(SC.partner)) {
			initializeBooleanPreference('refinement_links', true);
		}

		if (isSuperfishOk()) {
			injectSuperfish();
		}

		if (areRoamingSuggestionsOk()) {
			injectPredictAd();
		}

		try {
			var iframeHref = (window.top === window) ? document.location.href : document.referrer;
			if (iframeHref && !contains(iframeHref, SC.currentDomain) && !(onSCWebSitePage('scCustomizePage') || onSCWebSitePage('scSearchLinksPage') || onSCWebSitePage('scSuperfishPage'))) {
				return;
			}
		} catch (e) {}

		if (onSCWebSitePage('scCustomizePage')) {
			installSCClickHandler(document, customizePageClickHandler);
			if (scIsOldIE) {
				document.attachEvent('onkeydown', customizePageKeyHandler);
			}
			updateCustomizePage();
		} else if (onSCWebSitePage('scSuperfishPage')) {
			addBooleanPreferenceButton('superfish_button', getDisplaySimilarProductImages, setDisplaySimilarProductImages, 'Similar Product Images');
		} else if (onSCWebSitePage('scRoamingSuggestionsPage')) {
			addBooleanPreferenceButton('roaming_suggestions_button', getRoamingSuggestionsEnabled, setRoamingSuggestionsEnabled, 'Roaming Search Suggestions');
		} else if (onSCWebSitePage('scSearchLinksPage')) {
			addBooleanPreferenceButton('search_links_button', getSearchLinksEnabled, setSearchLinksEnabled, 'Search Links');
		} else if (onSCWebSitePage('scResetPage')) {
			setInstId(bigRandom());
		}

		if (onSCWebSitePage('scUserDataPage')) {
			var topLevel = make('div');
			var div = make('div');
			div.textContent = 'Version of surfcanyon.js: ' + SC.extensionVersion;
			topLevel.appendChild(div);
			div = make('div');
			div.textContent = 'InstId: ' + SC.instId;
			topLevel.appendChild(div);
			div = make('div');
			div.textContent = 'Partner: ' + SC.partner;
			topLevel.appendChild(div);
			div = make('div');
			div.textContent = 'Host: ' + SC.host;
			topLevel.appendChild(div);
			div = make('div');
			div.textContent = 'User Agent: ' + navigator.userAgent;
			topLevel.appendChild(div);
			document.body.appendChild(topLevel);
		} else if (onSCWebSitePage('scPreferencesPage')) {
			fillInPreferencesPage();
		} else if (onGoogleSerp()) {
			SERP = new GoogleSERP();
		} else if (onYahooShopping()) {
			SERP = new YahooShoppingSERP();
		} else if (onYahooSerp()) {
			SERP = new YahooSERP();
		}

		if (SERP) {
			mergeProperties(SC, SERP.getBehavior());
			waitForSerpAjaxToComplete();
		} else {
			updateDynamicPreferences();
			setupSearchLinks();
		}

	} catch (e2) {}
}

function fillInPreferenceArrays(boolPreferences, charPreferences) {
	var preferences = []; // todo: get prefs list from build.xml
	preferences = ['disabled', 'display_similar_product_images_enabled', 'dynamic_preferences_timestamp', 'get_recs_on_sr_click', 'google_search_button_click_ts', 'google_search_button_click_query', 'initialized_display_similar_product_images', 'initialized_refinement_links', 'initialized_roaming_suggestions', 'initialized_search_links', 'initialized_ss_page_links', 'inst_id', 'inst_timestamp', 'last_seen_splash', 'max_num_recs', 'num_recs_clicked', 'num_results_clicked', 'num_results_clicked_when_recs_available', 'num_searches', 'odometer_disabled', 'partner_code', 'refinements_cache', 'refinement_links_enabled', 'roaming_suggestions_enabled', 'search_links_enabled', 'ss_page_links_enabled'];

	var name, isBoolean;
	for (var i = 0; i < preferences.length; i++) {
		name = preferences[i];
		isBoolean = startsWith(name, 'init') || endsWith(name, 'abled') || (name === 'get_recs_on_sr_click');
		if (isBoolean) {
			boolPreferences.push(name);
		} else {
			charPreferences.push(name);
		}
	}

	if (scIsIE) {
		charPreferences.push('mode');
	}
}

function fillInPreferencesPage() {
	var boolPreferences = [];
	var charPreferences = [];
	fillInPreferenceArrays(boolPreferences, charPreferences);

	var mainDiv = make('div');
	var table = make('table');
	table.style.marginBottom = '20px';
	mainDiv.appendChild(table);
	var i, tr, td, name, value, label, input, html, div;
	for (i = 0; i < boolPreferences.length; i++) {
		if (i % 3 === 0) {
			tr = make('tr');
			table.appendChild(tr);
		}

		name = boolPreferences[i];
		value = getBoolPref(name);
		html = '<label><input type="checkbox" id="' + name + '"' + (value ? ' checked=true' : '') + '>' + name + '</label>';

		td = make('td');
		td.style.paddingRight = '20px';
		td.innerHTML = html; // NO_MOZ
		tr.appendChild(td);
	}
	for (i = 0; i < charPreferences.length; i++) {
		name = charPreferences[i];
		value = getCharPref(name) || '';
		label = '<label for="' + name + '">' + name + '</label>';
		input = (name === 'refinements_cache') ?
		('<textarea rows="10" cols="100" id="' + name + '">' + value + '</textarea>') :
		('<input type="text" size=40 id="' + name + '" value="' + value + '">');
		html = label + ': ' + input;

		div = make('div');
		div.innerHTML = html; // NO_MOZ
		mainDiv.appendChild(div);
	}
	var saveButton = make('button');
	saveButton.style.margin = '20px';
	saveButton.textContent = 'Save Preferences';
	installSCClickHandler(saveButton, savePreferences);
	mainDiv.appendChild(saveButton);
	document.body.appendChild(mainDiv);
}

function savePreferences() {
	if (!onSCWebSitePage('scPreferencesPage')) {
		return;
	}

	var boolPreferences = [];
	var charPreferences = [];
	fillInPreferenceArrays(boolPreferences, charPreferences);

	var i, name, value;
	for (i = 0; i < charPreferences.length; i++) {
		try {
			name = charPreferences[i];
			value = getById(name).value;
			setCharPreferenceValue(name, value);
		} catch (e) {}
	}
	for (i = 0; i < boolPreferences.length; i++) {
		try {
			name = boolPreferences[i];
			value = getById(name).checked;
			setBoolPreferenceValue(name, value);
		} catch (e) {}
	}

	alert('Preferences saved');
}

function getProductName() {
	return isAI(SC.partner) ? 'Search Assistant' : 'Fast Search';
}

function addBooleanPreferenceButton(divId, getter, setter, name) {
	var div = getById(divId);
	var isOn = false;
	try {
		isOn = getter();
	} catch (e) {}
	addPrefButtonToDiv(div, name, isOn);

	installSCClickHandler(div, function () {
		var isOn = false;
		try {
			isOn = getter();
		} catch (e) {}
		isOn = !isOn;

		setter(isOn);
		addPrefButtonToDiv(div, name, isOn);
	});
}

function addPrefButtonToDiv(div, name, isOn) {
	var button = make('button');
	button.textContent = 'Turn ' + name + ' ' + (isOn ? 'OFF' : 'ON');
	removeChildNodes(div);
	div.appendChild(button);
}

function removeChildNodes(node) {
	while (node.firstChild) {
		node.removeChild(node.firstChild);
	}
}

function addPageStyle(css) {
	var head = getTags('head')[0];

	var style = make('style');
	style.type = 'text/css';
	if (style.styleSheet) {
		style.styleSheet.cssText = css;
	} else {
		style.appendChild(document.createTextNode(css));
	}

	head.appendChild(style);
}

function getQueryFromGoogleSerp() {
	var aTags = getTags('a'),
	i,
	len = aTags.length;
	for (i = 0; i < len; i++) {
		var aTag = aTags[i];
		var href = aTag.href;
		if ((contains(href, '.google.') || href.charAt(0) == '/') && (contains(href, '/advanced_search?q=') || contains(href, '/swr?q='))) {
			SC.query = href.replace(/.*\?q=/, '').replace(/&.*/, '');
			return;
		}
	}
}

function googleAjaxPollingLoop() {
	SC.prevQuery = SC.query;
	SC.queryChangedPrev = SC.queryChanged;

	getQueryFromGoogleSerp();
	SC.queryChanged = (SC.query != SC.prevQuery);

	var invoke = (SC.queryChangedPrev && !SC.queryChanged) || SC.forceReinvokeExtensionInit;
	SC.forceReinvokeExtensionInit = false;
	var didIt = invoke ? setupForExtensionInit() : false;
	if (!didIt) {
		setTimeout(googleAjaxPollingLoop, 900);
	}
}

function waitForSerpAjaxToComplete() {
	if (!SC.query && onGoogleSerp()) {
		getQueryFromGoogleSerp();

		if (!SC.query) {
			setTimeout(waitForSerpAjaxToComplete, 1000);
			return;
		}
	}

	if (!setupForExtensionInit()) {
		setTimeout(waitForSerpAjaxToComplete, 1000);
		return;
	}
}

function addTopOfPageRefinementsDiv() {
	if (doAddTopOfPageRefinements() && onSerpThatSupportsReranking() && !getById('scTopOfPageRefinementLinks')) {
		try {
			var node = scSRNodes[0];
			while (node && node.parentNode) {
				if (node.tagName == 'OL') {
					var div = make("div");
					div.setAttribute('id', 'scTopOfPageRefinementLinks');
					div.style.height = '20px';
					div.style.marginTop = '7px';
					div.style.marginBottom = '7px';
					if (onYahooSerp()) {
						div.style.marginLeft = '10px';
					}

					node.parentNode.insertBefore(div, node);
					break;
				}
				node = node.parentNode;
			}
		} catch (e) {}
	}
}

function setupForExtensionInit() {
	if (!SC.query) {
		return false;
	}
	SC.query = decodeEntities(SC.query);

	scSRNodes = SERP.scGetSRNodes(null);
	if (!scSRNodes || (scSRNodes.length === 0)) {
		return false;
	}

	if (scIsFF || scIsSafari) {
		window.addEventListener('pageshow', pageshowHandler, false);
		window.addEventListener('pagehide', pagehideHandler, false);
	}

	addTopOfPageRefinementsDiv();

	if (!getAllDisabled()) {
		try {
			callExtensionInit();
		} catch (e) {
			log(e.message);
		}
	}

	return true;
}

function constructSearchResultURLListArgs() {
	var srURLs = '';
	var httpArgs = '';
	var numResults = scSRNodes.length;
	var i;
	for (i = 0; i < numResults; i++) {
		var srNode = scSRNodes[i];
		var displayUrl = SERP.extractUrlFromSRNode(srNode);
		if (displayUrl) {
			var urlHash = getUrlHash(displayUrl);
			srURLs = (srURLs ? (srURLs + ',' + urlHash) : urlHash);

			var realUrl;
			try {
				var titleTag = getTitleTag(srNode);
				var aTag = getChildrenByTagName(titleTag, "a")[0];
				httpArgs = httpArgs + '&title' + i + '=' + encodeURIComponent(aTag.innerHTML);

				var guessAtClickUrl = aTag.href; // it's a guess since some oddly formatted results might have the first link not be the clickable title link
				if (getDomainName(guessAtClickUrl) === getDomainName(displayUrl)) {
					realUrl = guessAtClickUrl;
				} else {
					realUrl = displayUrl;
				}
			} catch (ee) {}

			httpArgs = httpArgs + '&url' + i + '=' + encodeURIComponent(realUrl);
		}
	}

	return '&nativeSerpSearchResultUrls=' + srURLs + httpArgs + '&numResultsOnPage=' + numResults;
}

function callExtensionInit() {
	var srDataArgs = constructSearchResultURLListArgs();
	var adData = onTestServer() ? getAdData() : '';
	var yahooShoppingBlockArg = (onTestServer() && getYahooShoppingBlockScheme()) ? '&yahooShoppingBlock=1' : '';
	sc_ajax({
		method : 'POST',
		url : SC.host + 'search/extensionInit',
		headers : {
			'Content-type' : 'application/x-www-form-urlencoded'
		},
		data : 'ssMapKey=' + getSSMapKey() +
		'&serpUrl=' + encodeURIComponent(getPageUrl()) +
		'&instId=' + SC.instId +
		'&p=' + SC.partner +
		'&instTimestamp=' + SC.instTimestamp +
		'&extensionVersion=' + SC.extensionVersion +
		'&searchString=' + encodeURIComponent(SC.query) +
		'&searchEngine=' + SC.searchEngine +
		'&lang=' + getLangFromDomain(SC.currentDomain) +
		'&numResultsPerPage=' + getNumResultsPerPage() +
		srDataArgs + adData + yahooShoppingBlockArg,
		onload : function (xhr) {

			var text = getResponseText(xhr);

			if (isOkServerResponse(text)) {
				if (doAddTopOfPageRefinements() && onSerpThatSupportsReranking()) {
					addSerpRefinementLinks(1);
				}

				var xmlRoot = scXmlParser(text);
				var data = xmlRoot.getElementsByTagName('data')[0];
				if (data) {
					var userStatusNode = data.getElementsByTagName('userStatus')[0];
					scUserStatus = userStatusNode ? scGetText(userStatusNode) : "";

					if (scUserStatus != '0') {
						var sessionStatusNode = data.getElementsByTagName('sessionStatus')[0];
						if (sessionStatusNode) {
							processDataFromExtensionInit(data);
							if (!getAllDisabled()) {
								var node = data.getElementsByTagName('notEnoughResults')[0];
								if (scGetText(node) != '1') {
									initUI();
								}

								var sessionStatus = scGetText(sessionStatusNode);
								if (sessionStatus == '1') {
									if (SC.uploadResults) {
										SC.numBatchesLeftToUpload = SC.numSRsForInitialUpload / SC.batchSize;
										SC.batchNum = 1;
										uploadSRs();
									} else {
										// server received first batch via API instead of via upload
										SC.firstBatchReceived = true;
									}
									incNumSearches();
								} else {
									SC.continuingSession = true;
								}

								if (SC.continuingSession) {
									refreshDynamicContent();
								}

								if (onGoogleSerp()) {
									googleAjaxPollingLoop();
								}
							}
						}
					} else {
						if (onGoogleSerp()) {
							googleAjaxPollingLoop();
						}
					}
				}
			}
		}
	});
}

function processDataFromExtensionInit(data) {
	var numUserActionsNode = data.getElementsByTagName('numUserActions')[0];
	SC.numUserActions = scGetText(numUserActionsNode) === '1';

	var uploadResultsNode = data.getElementsByTagName('uploadResults')[0];
	SC.uploadResults = scGetText(uploadResultsNode) === '1';
}

function isOnSecurePage() {
	return (window.location.protocol === 'https:');
}

function isOnSuperfishFrame() {
	return contains(document.body.innerHTML, 'superfish.com/ws/');
}

function isOnProtectedDomain() {
	var domain = SC.currentDomain;
	return onSCPage() || contains(domain, '.google.') || contains(domain, '.yahoo.') || contains(domain, '.bing.') || contains(domain, '.live.') || contains(domain, 'mail.') || contains(domain, 'calendar.') || endsWith(domain, '.gov') || endsWith(domain, '.mil');
}

function isOnDataPage() {
	var url = window.location.href;
	return endsWith(url, '.pdf') || endsWith(url, '.txt') || endsWith(url, '.xml') || endsWith(url, '.json');
}

function disableMostExtraFeatures(scSerpOk) {
	return isOnSuperfishFrame() || isOnDataPage() || (isOnProtectedDomain() && !(scSerpOk && onSCSerp()));
}

function isSuperfishOk() {
	var scSerpOk = isSpecialPartner(SC.partner);
	return getDisplaySimilarProductImages() && !(isOnSecurePage() || disableMostExtraFeatures(scSerpOk));
}

function isVigLinkOk() {
	return !(isOnSecurePage() || disableMostExtraFeatures());
}

function areRoamingSuggestionsOk() {
	var domain = SC.currentDomain;
	return getRoamingSuggestionsEnabled() && !(isOnSecurePage() || disableMostExtraFeatures() || endsWith(domain, 'netflix.com') || endsWith(domain, 'opentable.com'));
}

function areSearchLinksOk() {
	return getSearchLinksEnabled() && !disableMostExtraFeatures();
}

function setupSearchLinks() {
	if (!areSearchLinksOk() || (typeof scSearchLinksInvoked !== 'undefined')) {
		return;
	}
	scSearchLinksInvoked = true;

	if (getServerSidePageLinksEnabled()) {
		addServerSidePageLinks();
	}

	clientSideSearchLinks();
}

function addServerSidePageLinks() {
	var pageUrl = getPageUrl();
	if (startsWith(pageUrl, 'https')) {
		var pos = pageUrl.indexOf('?');
		if (pos > 0) {
			pageUrl = pageUrl.substring(0, pos);
		}
	}

	var url = SC.host + 'pageLinks?instId=' + SC.instId + '&p=' + SC.partner + '&url=' + pageUrl;
	sc_ajax({
		method : 'GET',
		url : url,
		onload : function (xhr) {
			var terms = [],
			i;

			var text = getResponseText(xhr);
			var xmlRoot = scXmlParser(text);
			var matches = xmlRoot.getElementsByTagName('match'),
			len = matches.length;
			for (i = 0; i < len; i++) {
				var term = scGetText(matches[i].getElementsByTagName('term')[0]);
				terms.push(term);
			}

			var textNodes = [];
			addTextNodesToArray(document.body, textNodes);
			addSearchLinks(terms, textNodes, 's');
		}
	});
}

function addVigLink() {
	if (!areSearchLinksOk() || (typeof scVigLinksInvoked !== 'undefined')) {
		return;
	}
	scVigLinksInvoked = true;

	try { // NO_MOZ
		if (isVigLinkOk()) { // NO_MOZ
			var body = getTags("body")[0]; // NO_MOZ

			var vars = "var vglnk = { api_url: '//api.viglink.com/api', key: 'a187ca0f52aa99eb8b5c172d5d93c05b' };"; // NO_MOZ

			var script = make('script'); // NO_MOZ
			script.appendChild(document.createTextNode(vars)); // NO_MOZ
			body.appendChild(script); // NO_MOZ

			script = make('script'); // NO_MOZ
			script.type = 'text/javascript'; // NO_MOZ
			script.async = 'true'; // NO_MOZ
			script.src = ('https:' == document.location.protocol ? '//api' : '//cdn') + '.viglink.com/api/vglnk.js'; // NO_MOZ
			body.appendChild(script); // NO_MOZ
		} // NO_MOZ
	} catch (e) { // NO_MOZ
	} // NO_MOZ
}

function doAddTopOfPageRefinements() {
	return getRefinementLinksEnabled() && !onYahooShopping();
}

function appendSerpRefinementLink(node, q, position) {
	var link = make('a');
	link.href = constructDestinationSiteUrl(q, 'nrl' + position);
	link.textContent = q;
	link.style.fontSize = '13px';
	link.style.fontWeight = 'bold';
	link.style.marginRight = '9px';
	node.appendChild(link);
}

function appendSerpRefinementsLabel(node) {
	var span = make('span');
	span.textContent = getProductName() + ' Refinements';
	span.style.fontSize = '13px';
	span.style.color = 'darkgray';
	span.style.marginLeft = '7px';
	node.appendChild(span);

	span = make('span');
	span.id = 'scRemoveRefinements';
	span.style.marginLeft = '4px';
	span.style.fontSize = '11px';
	span.style.color = 'gray';
	span.style.cursor = 'pointer';
	span.textContent = 'X';
	node.appendChild(span);
}

function addSerpRefinementLinks(isFirstInvocation) {
	addTopOfPageRefinementsDiv();

	var refDiv = getById('scTopOfPageRefinementLinks');
	var q = SC.query.replace(/ /g, '+');
	if (q.length <= 15 && !isStopWord(q) && !refDiv.innerHTML.length) {
		var displayQuery = decodeURIComponent(SC.query.replace(/\+/g, ' '));
		displayQuery.substring(0, 1).toUpperCase() + displayQuery.substring(1);

		var span = make('span');
		appendSerpRefinementLink(span, displayQuery, 0);
		appendSerpRefinementsLabel(span);
		refDiv.appendChild(span);
	}

	var url = SC.host + 'queryReformulation?p=' + SC.partner + '&authCode=tjk49180&q=' + q;
	sc_ajax({
		method : 'GET',
		url : url,
		onload : function (xhr) {
			var xml = getResponseText(xhr);
			if (isOkServerResponse(xml) && containsHtml(xml)) {
				try {
					var span = make('span');

					var xmlRoot = scXmlParser(xml);
					var data = xmlRoot.getElementsByTagName('data')[0];
					if (data) {
						var refinements = data.getElementsByTagName('refinement');
						var len = refinements.length;
						if (len) {
							for (i = 0; i < len; i++) {
								var refinement = scGetText(refinements[i]);
								if (refinement) {
									appendSerpRefinementLink(span, refinement, i);
								}
							}
						}
					}

					appendSerpRefinementsLabel(span);

					removeChildren(refDiv);
					refDiv.textContent = '';
					refDiv.appendChild(span);

					if (getSearchLinksEnabled()) {
						cacheRefinements(refDiv);
					}
				} catch (e) {}
			} else if (isFirstInvocation) {
				addRefsOnceFirstBatchReceived();
			}
		}
	});
}

function removeRefinements() {
	openNewTab('http://my.surfcanyon.com/');
}

function addRefsOnceFirstBatchReceived() {
	if (SC.firstBatchReceived) {
		addSerpRefinementLinks();
	} else {
		setTimeout(addRefsOnceFirstBatchReceived, 1000);
	}
}

function isStopWord(s) {
	var stopwords = ['the', 'of', 'and', 'a', 'an', 'to', 'in', 'is', 'you', 'that', 'it',
		'about', 'above', 'across', 'after', 'afterward', 'again', 'against', 'all',
		'almost', 'along', 'already', 'also', 'although', 'always', 'among', 'another',
		'any', 'anyhow', 'anyone', 'anything', 'anyway', 'anywhere', 'are', 'area',
		'around', 'as', 'at', 'away', 'back', 'be', 'became', 'because', 'become',
		'becoming', 'been', 'before', 'beforehand', 'behind', 'being', 'below', 'beside',
		'between', 'beyond', 'big', 'both', 'but', 'by', 'call', 'can', 'cannot',
		'could', 'did', 'do', 'does', 'done', 'down', 'due', 'during', 'each', 'either',
		'else', 'elsewhere', 'empty', 'etc', 'even', 'ever', 'every', 'everyone',
		'everything', 'everywhere', 'except', 'for', 'former', 'from', 'further',
		'get', 'good', 'had', 'have', 'he', 'her', 'here', 'herself', 'him', 'himself',
		'his', 'how', 'however', 'if', 'into', 'its', 'itself', 'join', 'just', 'keep',
		'last', 'least', 'less', 'let', 'like', 'many', 'may', 'might', 'more', 'most',
		'much', 'must', 'myself', 'near', 'nearby', 'neither', 'never', 'next',
		'no', 'nobody', 'none', 'nor', 'not', 'nothing', 'now', 'nowhere', 'off',
		'often', 'on', 'once', 'one', 'only', 'onto', 'or', 'other', 'otherwise',
		'our', 'ours', 'out', 'over', 'own', 'per', 'perhaps', 'put', 'rather',
		'see', 'seem', 'self', 'set', 'several', 'she', 'should', 'sign', 'since',
		'so', 'some', 'somehow', 'someone', 'something', 'sometime', 'sometimes',
		'somewhere', 'still', 'such', 'than', 'their', 'theirs', 'them', 'then',
		'there', 'these', 'they', 'this', 'those', 'though', 'through', 'throughout',
		'thru', 'too', 'toward', 'under', 'until', 'up', 'upon', 'very', 'was', 'way',
		'well', 'went', 'were', 'what', 'whatever', 'when', 'whenever',
		'where', 'wherever', 'whether', 'which', 'while', 'who', 'whoever', 'whom',
		'whose', 'why', 'will', 'with', 'within', 'without', 'word', 'would',
		'yet', 'your', 'yourself'];

	var i,
	num = stopwords.length;
	for (i = 0; i < num; i++) {
		if (stopwords[i] === s) {
			return true;
		}
	}

	return false;
}

function domainIs(d) {
	return (SC.currentDomain === d) || endsWith(SC.currentDomain, '.' + d);
}

function onFacebookPage() {
	return domainIs('facebook.com') && !contains(getPageUrl(), '/messages/');
}

function onSCSerp() {
	return onSCPage() && getById('formWithSuggest') && getById('dynamicContent');
}

function onSCPage() {
	return domainIs('surfcanyon.com') || (SC.currentDomain == 'localhost');
}

YSGridRows = {
	initRows : function () {
		if (!this.gridRows) {
			this.gridRows = {};
		}
		var root = getById('web');
		if (!root) {
			return null;
		}
		var roots = getChildrenByTagAndClass(root, 'ol', 'grid');

		for (var i = 0; i < roots.length; i++) {
			if (roots[i].getAttribute('scGridItem')) { continue; }
			this.addRowsFromParent(roots[i]);
			roots[i].setAttribute('scGridItem', 'true');
		}
		return root;
	},
	addRowsFromParent : function (parent) {
		var childNodes = getChildrenByTagName(parent, 'li');
		var row = [];
		for (var x = 0; x < childNodes.length; x++) {
			if (contains(childNodes[x].className, 'row-last')) {
				row.push(childNodes[x]);
				this.addRow(row, parent, childNodes[x], false);
				row = [];
			} else if ((!contains(childNodes[x].className, 'hr')) && !contains(childNodes[x].className, 'clear')) {
				row.push(childNodes[x]);
			}
		}
	},
	addRow : function (nodes, parent, relativeNode) {
		for (var i = 0; i < nodes.length; i++) {
			if (!(contains(nodes[i].className, 'hr') || contains(nodes[i].className, 'clear'))) {
				var urlHash = nodes[i].getAttribute('scUrlHash');

				if (!urlHash) {
					urlHash = getUrlHash(SERP.extractUrlFromSRNode(nodes[i]));
					nodes[i].setAttribute('scUrlHash', urlHash);
				}
				this.gridRows[urlHash] = {homeOl: parent, target: relativeNode, recsShown: false};
			}
		}
	},
	addRecs : function (urlHash, recs) {
		var gridRow = this.gridRows[urlHash];
		if (!gridRow || gridRow.recsShown) {
			return;
		}

		var recsDiv = make('div');
		recsDiv.style.marginLeft = '210px';
		gridRow.homeOl.insertBefore(recsDiv, gridRow.target.nextSibling);

		appendSafeHtml(recs, function(html) {
			recsDiv.innerHTML = html;
		});

		var divider = recsDiv.parentNode.insertBefore(make('li'), recsDiv);
		divider.className = 'hr';
		recsDiv.setAttribute('scRecsAdded', 'true');

		gridRow.recsShown = true;
		this.addRow(recsDiv.childNodes, gridRow.homeOl, recsDiv);
	}
};

try {
	if (scIsIE) {
		if (document.readyState === 'complete') {
			// 5.2.0 DLL and higher
			setup();
		} else {
			// older DLLs
			if (window.frames.length) {
				var i;
				for (i = 0; i < window.frames.length; i++) {
					try {
						window.frames[i].attachEvent('onload', setup);
					} catch (e) {}
				}
			} else {
				window.attachEvent('onload', setup);
			}
		}
	} else if (!scInitializedByBackgroundPage) {
		setup();
	}
} catch (ee) {}

//FOR-IE }; // closes surfcanyonWrapperObject
//FOR-IE surfcanyonWrapperObject();

